CONST
    DFS_VOLUME_STATE_OK=1;
    DFS_VOLUME_STATE_INCONSISTENT=2;
    DFS_VOLUME_STATE_OFFLINE=3;
    DFS_VOLUME_STATE_ONLINE=4;
    DFS_STORAGE_STATE_OFFLINE=1;
    DFS_STORAGE_STATE_ONLINE=2;
    DFS_STORAGE_STATE_ACTIVE=4;
    DFS_ADD_VOLUME=1;// Add a new volume to the DFS if not already there
    DFS_RESTORE_VOLUME=2;// Volume/Replica is being restored - do not verify share etc.
    NET_DFS_SETDC_FLAGS=$00000000;
    NET_DFS_SETDC_TIMEOUT=$00000001;
    NET_DFS_SETDC_INITPKT=$00000002;
    DFS_SITE_PRIMARY=$1;// This site returned by DsGetSiteName()
    SERVICE_WORKSTATION='LanmanWorkstation';
    SERVICE_LM20_WORKSTATION='WORKSTATION';
    WORKSTATION_DISPLAY_NAME='Workstation';
    SERVICE_SERVER='LanmanServer';
    SERVICE_LM20_SERVER='SERVER';
    SERVER_DISPLAY_NAME='Server';
    SERVICE_BROWSER='BROWSER';
    SERVICE_LM20_BROWSER=SERVICE_BROWSER;
    SERVICE_MESSENGER='MESSENGER';
    SERVICE_LM20_MESSENGER=SERVICE_MESSENGER;
    SERVICE_NETRUN='NETRUN';
    SERVICE_LM20_NETRUN=SERVICE_NETRUN;
    SERVICE_SPOOLER='SPOOLER';
    SERVICE_LM20_SPOOLER=SERVICE_SPOOLER;
    SERVICE_ALERTER='ALERTER';
    SERVICE_LM20_ALERTER=SERVICE_ALERTER;
    SERVICE_NETLOGON='NETLOGON';
    SERVICE_LM20_NETLOGON=SERVICE_NETLOGON;
    SERVICE_NETPOPUP='NETPOPUP';
    SERVICE_LM20_NETPOPUP=SERVICE_NETPOPUP;
    SERVICE_SQLSERVER='SQLSERVER';
    SERVICE_LM20_SQLSERVER=SERVICE_SQLSERVER;
    SERVICE_REPL='REPLICATOR';
    SERVICE_LM20_REPL=SERVICE_REPL;
    SERVICE_RIPL='REMOTEBOOT';
    SERVICE_LM20_RIPL=SERVICE_RIPL;
    SERVICE_TIMESOURCE='TIMESOURCE';
    SERVICE_LM20_TIMESOURCE=SERVICE_TIMESOURCE;
    SERVICE_AFP='AFP';
    SERVICE_LM20_AFP=SERVICE_AFP;
    SERVICE_UPS='UPS';
    SERVICE_LM20_UPS=SERVICE_UPS;
    SERVICE_XACTSRV='XACTSRV';
    SERVICE_LM20_XACTSRV=SERVICE_XACTSRV;
    SERVICE_TCPIP='TCPIP';
    SERVICE_LM20_TCPIP=SERVICE_TCPIP;
    SERVICE_NBT='NBT';
    SERVICE_LM20_NBT=SERVICE_NBT;
    SERVICE_LMHOSTS='LMHOSTS';
    SERVICE_LM20_LMHOSTS=SERVICE_LMHOSTS;
    SERVICE_TELNET='Telnet';
    SERVICE_LM20_TELNET=SERVICE_TELNET;
    SERVICE_SCHEDULE='Schedule';
    SERVICE_LM20_SCHEDULE=SERVICE_SCHEDULE;
    SERVICE_NTLMSSP='NtLmSsp';
    SERVICE_DHCP='DHCP';
    SERVICE_LM20_DHCP=SERVICE_DHCP;
    SERVICE_NWSAP='NwSapAgent';
    SERVICE_LM20_NWSAP=SERVICE_NWSAP;
    NWSAP_DISPLAY_NAME='NW Sap Agent';
    SERVICE_NWCS='NWCWorkstation';
    SERVICE_DNS_CACHE='DnsCache';
    SERVICE_W32TIME='w32time';
    SERVCE_LM20_W32TIME=SERVICE_W32TIME;
    SERVICE_KDC='kdc';
    SERVICE_LM20_KDC=SERVICE_KDC;
    SERVICE_RPCLOCATOR='RPCLOCATOR';
    SERVICE_LM20_RPCLOCATOR=SERVICE_RPCLOCATOR;
    SERVICE_TRKSVR='TrkSvr';
    SERVICE_LM20_TRKSVR=SERVICE_TRKSVR;
    SERVICE_TRKWKS='TrkWks';
    SERVICE_LM20_TRKWKS=SERVICE_TRKWKS;
    SERVICE_NTFRS='NtFrs';
    SERVICE_LM20_NTFRS=SERVICE_NTFRS;
    SERVICE_ISMSERV='IsmServ';
    SERVICE_LM20_ISMSERV=SERVICE_ISMSERV;
    SUPPORTS_REMOTE_ADMIN_PROTOCOL=$00000002;
    SUPPORTS_RPC=$00000004;
    SUPPORTS_SAM_PROTOCOL=$00000008;
    SUPPORTS_UNICODE=$00000010;
    SUPPORTS_LOCAL=$00000020;
    SUPPORTS_ANY=$FFFFFFFF;
    NO_PERMISSION_REQUIRED=$00000001;// set if use NULL session
    ALLOCATE_RESPONSE=$00000002;// set if RxRemoteApi allocates response buffer
    USE_SPECIFIC_TRANSPORT=$80000000;
    NETSETUP_JOIN_DOMAIN=$00000001;// If not present, workgroup is joined
    NETSETUP_ACCT_CREATE=$00000002;// Do the server side account creation/rename
    NETSETUP_ACCT_DELETE=$00000004;// Delete the account when a domain is left
    NETSETUP_WIN9X_UPGRADE=$00000010;// Invoked during upgrade of Windows 9x to NT
    NETSETUP_DOMAIN_JOIN_IF_JOINED=$00000020;// Allow the client to join a new domain
    NETSETUP_JOIN_UNSECURE=$00000040;// Performs an unsecure join
    NETSETUP_INSTALL_INVOCATION=$00040000;// The APIs were invoked during install
    STATSOPT_CLR=1;
    STATS_NO_VALUE=DWORD(-1);
    STATS_OVERFLOW=DWORD(-2);
    USE_LOCAL_PARMNUM=1;
    USE_REMOTE_PARMNUM=2;
    USE_PASSWORD_PARMNUM=3;
    USE_ASGTYPE_PARMNUM=4;
    USE_USERNAME_PARMNUM=5;
    USE_DOMAINNAME_PARMNUM=6;
    USE_OK=0;
    USE_PAUSED=1;
    USE_SESSLOST=2;
    USE_DISCONN=2;
    USE_NETERR=3;
    USE_CONN=4;
    USE_RECONN=5;
    USE_WILDCARD=DWORD(-1);
    USE_DISKDEV=0;
    USE_SPOOLDEV=1;
    USE_CHARDEV=2;
    USE_IPC=3;
    CREATE_NO_CONNECT=$1;// creation flags
    CREATE_BYPASS_CSC=$2;// force connection to server, bypassing CSC
    MSGNAME_NOT_FORWARDED=0;// Name not forwarded
    MSGNAME_FORWARDED_TO=$04;// Name forward to remote station
    MSGNAME_FORWARDED_FROM=$10;// Name forwarded from remote station
    USE_NOFORCE=0;
    USE_FORCE=1;
    USE_LOTS_OF_FORCE=2;
    ALERTER_MAILSLOT='\\.\MAILSLOT\Alerter';
    ALERT_PRINT_EVENT='PRINTING';
    ALERT_MESSAGE_EVENT='MESSAGE';
    ALERT_ERRORLOG_EVENT='ERRORLOG';
    ALERT_ADMIN_EVENT='ADMIN';
    ALERT_USER_EVENT='USER';
    PRJOB_QSTATUS=$3;// Bits 0,1
    PRJOB_DEVSTATUS=$1FC;// 2-8 bits
    PRJOB_COMPLETE=$4;// Bit 2
    PRJOB_INTERV=$8;// Bit 3
    PRJOB_ERROR=$10;// Bit 4
    PRJOB_DESTOFFLINE=$20;// Bit 5
    PRJOB_DESTPAUSED=$40;// Bit 6
    PRJOB_NOTIFY=$80;// BIT 7
    PRJOB_DESTNOPAPER=$100;// BIT 8
    PRJOB_DELETED=$8000;// BIT 15
    PRJOB_QS_QUEUED=0;
    PRJOB_QS_PAUSED=1;
    PRJOB_QS_SPOOLING=2;
    PRJOB_QS_PRINTING=3;
    JOB_RUN_PERIODICALLY=$01;//  set if EVERY
    JOB_EXEC_ERROR=$02;//  set if error
    JOB_RUNS_TODAY=$04;//  set if today
    JOB_ADD_CURRENT_DATE=$08;// set if to add current date
    JOB_NONINTERACTIVE=$10;// set for noninteractive
    JOB_INPUT_FLAGS=(JOB_RUN_PERIODICALLY OR JOB_ADD_CURRENT_DATE OR JOB_NONINTERACTIVE);
    JOB_OUTPUT_FLAGS=(JOB_RUN_PERIODICALLY OR JOB_EXEC_ERROR OR JOB_RUNS_TODAY OR JOB_NONINTERACTIVE);
    NERR_Success=0;
    NERR_BASE=2100;
    NERR_NetNotStarted=NERR_BASE+2;
    NERR_UnknownServer=NERR_BASE+3;
    NERR_ShareMem=NERR_BASE+4;
    NERR_NoNetworkResource=NERR_BASE+5;
    NERR_RemoteOnly=NERR_BASE+6;
    NERR_DevNotRedirected=NERR_BASE+7;
    NERR_ServerNotStarted=NERR_BASE+14;
    NERR_ItemNotFound=NERR_BASE+15;
    NERR_UnknownDevDir=NERR_BASE+16;
    NERR_RedirectedPath=NERR_BASE+17;
    NERR_DuplicateShare=NERR_BASE+18;
    NERR_NoRoom=NERR_BASE+19;
    NERR_TooManyItems=NERR_BASE+21;
    NERR_InvalidMaxUsers=NERR_BASE+22;
    NERR_BufTooSmall=NERR_BASE+23;
    NERR_RemoteErr=NERR_BASE+27;
    NERR_LanmanIniError=NERR_BASE+31;
    NERR_NetworkError=NERR_BASE+36;
    NERR_WkstaInconsistentState=NERR_BASE+37;
    NERR_WkstaNotStarted=NERR_BASE+38;
    NERR_BrowserNotStarted=NERR_BASE+39;
    NERR_InternalError=NERR_BASE+40;
    NERR_BadTransactConfig=NERR_BASE+41;
    NERR_InvalidAPI=NERR_BASE+42;
    NERR_BadEventName=NERR_BASE+43;
    NERR_DupNameReboot=NERR_BASE+44;
    NERR_CfgCompNotFound=NERR_BASE+46;
    NERR_CfgParamNotFound=NERR_BASE+47;
    NERR_LineTooLong=NERR_BASE+49;
    NERR_QNotFound=NERR_BASE+50;
    NERR_JobNotFound=NERR_BASE+51;
    NERR_DestNotFound=NERR_BASE+52;
    NERR_DestExists=NERR_BASE+53;
    NERR_QExists=NERR_BASE+54;
    NERR_QNoRoom=NERR_BASE+55;
    NERR_JobNoRoom=NERR_BASE+56;
    NERR_DestNoRoom=NERR_BASE+57;
    NERR_DestIdle=NERR_BASE+58;
    NERR_DestInvalidOp=NERR_BASE+59;
    NERR_ProcNoRespond=NERR_BASE+60;
    NERR_SpoolerNotLoaded=NERR_BASE+61;
    NERR_DestInvalidState=NERR_BASE+62;
    NERR_QInvalidState=NERR_BASE+63;
    NERR_JobInvalidState=NERR_BASE+64;
    NERR_SpoolNoMemory=NERR_BASE+65;
    NERR_DriverNotFound=NERR_BASE+66;
    NERR_DataTypeInvalid=NERR_BASE+67;
    NERR_ProcNotFound=NERR_BASE+68;
    NERR_ServiceTableLocked=NERR_BASE+80;
    NERR_ServiceTableFull=NERR_BASE+81;
    NERR_ServiceInstalled=NERR_BASE+82;
    NERR_ServiceEntryLocked=NERR_BASE+83;
    NERR_ServiceNotInstalled=NERR_BASE+84;
    NERR_BadServiceName=NERR_BASE+85;
    NERR_ServiceCtlTimeout=NERR_BASE+86;
    NERR_ServiceCtlBusy=NERR_BASE+87;
    NERR_BadServiceProgName=NERR_BASE+88;
    NERR_ServiceNotCtrl=NERR_BASE+89;
    NERR_ServiceKillProc=NERR_BASE+90;
    NERR_ServiceCtlNotValid=NERR_BASE+91;
    NERR_NotInDispatchTbl=NERR_BASE+92;
    NERR_BadControlRecv=NERR_BASE+93;
    NERR_ServiceNotStarting=NERR_BASE+94;
    NERR_AlreadyLoggedOn=NERR_BASE+100;
    NERR_NotLoggedOn=NERR_BASE+101;
    NERR_BadUsername=NERR_BASE+102;
    NERR_BadPassword=NERR_BASE+103;
    NERR_UnableToAddName_W=NERR_BASE+104;
    NERR_UnableToAddName_F=NERR_BASE+105;
    NERR_UnableToDelName_W=NERR_BASE+106;
    NERR_UnableToDelName_F=NERR_BASE+107;
    NERR_LogonsPaused=NERR_BASE+109;
    NERR_LogonServerConflict=NERR_BASE+110;
    NERR_LogonNoUserPath=NERR_BASE+111;
    NERR_LogonScriptError=NERR_BASE+112;
    NERR_StandaloneLogon=NERR_BASE+114;
    NERR_LogonServerNotFound=NERR_BASE+115;
    NERR_LogonDomainExists=NERR_BASE+116;
    NERR_NonValidatedLogon=NERR_BASE+117;
    NERR_ACFNotFound=NERR_BASE+119;
    NERR_GroupNotFound=NERR_BASE+120;
    NERR_UserNotFound=NERR_BASE+121;
    NERR_ResourceNotFound=NERR_BASE+122;
    NERR_GroupExists=NERR_BASE+123;
    NERR_UserExists=NERR_BASE+124;
    NERR_ResourceExists=NERR_BASE+125;
    NERR_NotPrimary=NERR_BASE+126;
    NERR_ACFNotLoaded=NERR_BASE+127;
    NERR_ACFNoRoom=NERR_BASE+128;
    NERR_ACFFileIOFail=NERR_BASE+129;
    NERR_ACFTooManyLists=NERR_BASE+130;
    NERR_UserLogon=NERR_BASE+131;
    NERR_ACFNoParent=NERR_BASE+132;
    NERR_CanNotGrowSegment=NERR_BASE+133;
    NERR_SpeGroupOp=NERR_BASE+134;
    NERR_NotInCache=NERR_BASE+135;
    NERR_UserInGroup=NERR_BASE+136;
    NERR_UserNotInGroup=NERR_BASE+137;
    NERR_AccountUndefined=NERR_BASE+138;
    NERR_AccountExpired=NERR_BASE+139;
    NERR_InvalidWorkstation=NERR_BASE+140;
    NERR_InvalidLogonHours=NERR_BASE+141;
    NERR_PasswordExpired=NERR_BASE+142;
    NERR_PasswordCantChange=NERR_BASE+143;
    NERR_PasswordHistConflict=NERR_BASE+144;
    NERR_PasswordTooShort=NERR_BASE+145;
    NERR_PasswordTooRecent=NERR_BASE+146;
    NERR_InvalidDatabase=NERR_BASE+147;
    NERR_DatabaseUpToDate=NERR_BASE+148;
    NERR_SyncRequired=NERR_BASE+149;
    NERR_UseNotFound=NERR_BASE+150;
    NERR_BadAsgType=NERR_BASE+151;
    NERR_DeviceIsShared=NERR_BASE+152;
    NERR_NoComputerName=NERR_BASE+170;
    NERR_MsgAlreadyStarted=NERR_BASE+171;
    NERR_MsgInitFailed=NERR_BASE+172;
    NERR_NameNotFound=NERR_BASE+173;
    NERR_AlreadyForwarded=NERR_BASE+174;
    NERR_AddForwarded=NERR_BASE+175;
    NERR_AlreadyExists=NERR_BASE+176;
    NERR_TooManyNames=NERR_BASE+177;
    NERR_DelComputerName=NERR_BASE+178;
    NERR_LocalForward=NERR_BASE+179;
    NERR_GrpMsgProcessor=NERR_BASE+180;
    NERR_PausedRemote=NERR_BASE+181;
    NERR_BadReceive=NERR_BASE+182;
    NERR_NameInUse=NERR_BASE+183;
    NERR_MsgNotStarted=NERR_BASE+184;
    NERR_NotLocalName=NERR_BASE+185;
    NERR_NoForwardName=NERR_BASE+186;
    NERR_RemoteFull=NERR_BASE+187;
    NERR_NameNotForwarded=NERR_BASE+188;
    NERR_TruncatedBroadcast=NERR_BASE+189;
    NERR_InvalidDevice=NERR_BASE+194;
    NERR_WriteFault=NERR_BASE+195;
    NERR_DuplicateName=NERR_BASE+197;
    NERR_DeleteLater=NERR_BASE+198;
    NERR_IncompleteDel=NERR_BASE+199;
    NERR_MultipleNets=NERR_BASE+200;
    NERR_NetNameNotFound=NERR_BASE+210;
    NERR_DeviceNotShared=NERR_BASE+211;
    NERR_ClientNameNotFound=NERR_BASE+212;
    NERR_FileIdNotFound=NERR_BASE+214;
    NERR_ExecFailure=NERR_BASE+215;
    NERR_TmpFile=NERR_BASE+216;
    NERR_TooMuchData=NERR_BASE+217;
    NERR_DeviceShareConflict=NERR_BASE+218;
    NERR_BrowserTableIncomplete=NERR_BASE+219;
    NERR_NotLocalDomain=NERR_BASE+220;
    NERR_IsDfsShare=NERR_BASE+221;
    NERR_DevInvalidOpCode=NERR_BASE+231;
    NERR_DevNotFound=NERR_BASE+232;
    NERR_DevNotOpen=NERR_BASE+233;
    NERR_BadQueueDevString=NERR_BASE+234;
    NERR_BadQueuePriority=NERR_BASE+235;
    NERR_NoCommDevs=NERR_BASE+237;
    NERR_QueueNotFound=NERR_BASE+238;
    NERR_BadDevString=NERR_BASE+240;
    NERR_BadDev=NERR_BASE+241;
    NERR_InUseBySpooler=NERR_BASE+242;
    NERR_CommDevInUse=NERR_BASE+243;
    NERR_InvalidComputer=NERR_BASE+251;
    NERR_MaxLenExceeded=NERR_BASE+254;
    NERR_BadComponent=NERR_BASE+256;
    NERR_CantType=NERR_BASE+257;
    NERR_TooManyEntries=NERR_BASE+262;
    NERR_ProfileFileTooBig=NERR_BASE+270;
    NERR_ProfileOffset=NERR_BASE+271;
    NERR_ProfileCleanup=NERR_BASE+272;
    NERR_ProfileUnknownCmd=NERR_BASE+273;
    NERR_ProfileLoadErr=NERR_BASE+274;
    NERR_ProfileSaveErr=NERR_BASE+275;
    NERR_LogOverflow=NERR_BASE+277;
    NERR_LogFileChanged=NERR_BASE+278;
    NERR_LogFileCorrupt=NERR_BASE+279;
    NERR_SourceIsDir=NERR_BASE+280;
    NERR_BadSource=NERR_BASE+281;
    NERR_BadDest=NERR_BASE+282;
    NERR_DifferentServers=NERR_BASE+283;
    NERR_RunSrvPaused=NERR_BASE+285;
    NERR_ErrCommRunSrv=NERR_BASE+289;
    NERR_ErrorExecingGhost=NERR_BASE+291;
    NERR_ShareNotFound=NERR_BASE+292;
    NERR_InvalidLana=NERR_BASE+300;
    NERR_OpenFiles=NERR_BASE+301;
    NERR_ActiveConns=NERR_BASE+302;
    NERR_BadPasswordCore=NERR_BASE+303;
    NERR_DevInUse=NERR_BASE+304;
    NERR_LocalDrive=NERR_BASE+305;
    NERR_AlertExists=NERR_BASE+330;
    NERR_TooManyAlerts=NERR_BASE+331;
    NERR_NoSuchAlert=NERR_BASE+332;
    NERR_BadRecipient=NERR_BASE+333;
    NERR_AcctLimitExceeded=NERR_BASE+334;
    NERR_InvalidLogSeek=NERR_BASE+340;
    NERR_BadUasConfig=NERR_BASE+350;
    NERR_InvalidUASOp=NERR_BASE+351;
    NERR_LastAdmin=NERR_BASE+352;
    NERR_DCNotFound=NERR_BASE+353;
    NERR_LogonTrackingError=NERR_BASE+354;
    NERR_NetlogonNotStarted=NERR_BASE+355;
    NERR_CanNotGrowUASFile=NERR_BASE+356;
    NERR_TimeDiffAtDC=NERR_BASE+357;
    NERR_PasswordMismatch=NERR_BASE+358;
    NERR_NoSuchServer=NERR_BASE+360;
    NERR_NoSuchSession=NERR_BASE+361;
    NERR_NoSuchConnection=NERR_BASE+362;
    NERR_TooManyServers=NERR_BASE+363;
    NERR_TooManySessions=NERR_BASE+364;
    NERR_TooManyConnections=NERR_BASE+365;
    NERR_TooManyFiles=NERR_BASE+366;
    NERR_NoAlternateServers=NERR_BASE+367;
    NERR_TryDownLevel=NERR_BASE+370;
    NERR_UPSDriverNotStarted=NERR_BASE+380;
    NERR_UPSInvalidConfig=NERR_BASE+381;
    NERR_UPSInvalidCommPort=NERR_BASE+382;
    NERR_UPSSignalAsserted=NERR_BASE+383;
    NERR_UPSShutdownFailed=NERR_BASE+384;
    NERR_BadDosRetCode=NERR_BASE+400;
    NERR_ProgNeedsExtraMem=NERR_BASE+401;
    NERR_BadDosFunction=NERR_BASE+402;
    NERR_RemoteBootFailed=NERR_BASE+403;
    NERR_BadFileCheckSum=NERR_BASE+404;
    NERR_NoRplBootSystem=NERR_BASE+405;
    NERR_RplLoadrNetBiosErr=NERR_BASE+406;
    NERR_RplLoadrDiskErr=NERR_BASE+407;
    NERR_ImageParamErr=NERR_BASE+408;
    NERR_TooManyImageParams=NERR_BASE+409;
    NERR_NonDosFloppyUsed=NERR_BASE+410;
    NERR_RplBootRestart=NERR_BASE+411;
    NERR_RplSrvrCallFailed=NERR_BASE+412;
    NERR_CantConnectRplSrvr=NERR_BASE+413;
    NERR_CantOpenImageFile=NERR_BASE+414;
    NERR_CallingRplSrvr=NERR_BASE+415;
    NERR_StartingRplBoot=NERR_BASE+416;
    NERR_RplBootServiceTerm=NERR_BASE+417;
    NERR_RplBootStartFailed=NERR_BASE+418;
    NERR_RPL_CONNECTED=NERR_BASE+419;
    NERR_BrowserConfiguredToNotRun=NERR_BASE+450;
    NERR_RplNoAdaptersStarted=NERR_BASE+510;
    NERR_RplBadRegistry=NERR_BASE+511;
    NERR_RplBadDatabase=NERR_BASE+512;
    NERR_RplRplfilesShare=NERR_BASE+513;
    NERR_RplNotRplServer=NERR_BASE+514;
    NERR_RplCannotEnum=NERR_BASE+515;
    NERR_RplWkstaInfoCorrupted=NERR_BASE+516;
    NERR_RplWkstaNotFound=NERR_BASE+517;
    NERR_RplWkstaNameUnavailable=NERR_BASE+518;
    NERR_RplProfileInfoCorrupted=NERR_BASE+519;
    NERR_RplProfileNotFound=NERR_BASE+520;
    NERR_RplProfileNameUnavailable=NERR_BASE+521;
    NERR_RplProfileNotEmpty=NERR_BASE+522;
    NERR_RplConfigInfoCorrupted=NERR_BASE+523;
    NERR_RplConfigNotFound=NERR_BASE+524;
    NERR_RplAdapterInfoCorrupted=NERR_BASE+525;
    NERR_RplInternal=NERR_BASE+526;
    NERR_RplVendorInfoCorrupted=NERR_BASE+527;
    NERR_RplBootInfoCorrupted=NERR_BASE+528;
    NERR_RplWkstaNeedsUserAcct=NERR_BASE+529;
    NERR_RplNeedsRPLUSERAcct=NERR_BASE+530;
    NERR_RplBootNotFound=NERR_BASE+531;
    NERR_RplIncompatibleProfile=NERR_BASE+532;
    NERR_RplAdapterNameUnavailable=NERR_BASE+533;
    NERR_RplConfigNotEmpty=NERR_BASE+534;
    NERR_RplBootInUse=NERR_BASE+535;
    NERR_RplBackupDatabase=NERR_BASE+536;
    NERR_RplAdapterNotFound=NERR_BASE+537;
    NERR_RplVendorNotFound=NERR_BASE+538;
    NERR_RplVendorNameUnavailable=NERR_BASE+539;
    NERR_RplBootNameUnavailable=NERR_BASE+540;
    NERR_RplConfigNameUnavailable=NERR_BASE+541;
    NERR_DfsInternalCorruption=NERR_BASE+560;
    NERR_DfsVolumeDataCorrupt=NERR_BASE+561;
    NERR_DfsNoSuchVolume=NERR_BASE+562;
    NERR_DfsVolumeAlreadyExists=NERR_BASE+563;
    NERR_DfsAlreadyShared=NERR_BASE+564;
    NERR_DfsNoSuchShare=NERR_BASE+565;
    NERR_DfsNotALeafVolume=NERR_BASE+566;
    NERR_DfsLeafVolume=NERR_BASE+567;
    NERR_DfsVolumeHasMultipleServers=NERR_BASE+568;
    NERR_DfsCantCreateJunctionPoint=NERR_BASE+569;
    NERR_DfsServerNotDfsAware=NERR_BASE+570;
    NERR_DfsBadRenamePath=NERR_BASE+571;
    NERR_DfsVolumeIsOffline=NERR_BASE+572;
    NERR_DfsNoSuchServer=NERR_BASE+573;
    NERR_DfsCyclicalName=NERR_BASE+574;
    NERR_DfsNotSupportedInServerDfs=NERR_BASE+575;
    NERR_DfsDuplicateService=NERR_BASE+576;
    NERR_DfsCantRemoveLastServerShare=NERR_BASE+577;
    NERR_DfsVolumeIsInterDfs=NERR_BASE+578;
    NERR_DfsInconsistent=NERR_BASE+579;
    NERR_DfsServerUpgraded=NERR_BASE+580;
    NERR_DfsDataIsIdentical=NERR_BASE+581;
    NERR_DfsCantRemoveDfsRoot=NERR_BASE+582;
    NERR_DfsChildOrParentInDfs=NERR_BASE+583;
    NERR_DfsInternalError=NERR_BASE+590;
    NERR_SetupAlreadyJoined=NERR_BASE+591;
    NERR_SetupNotJoined=NERR_BASE+592;
    NERR_SetupDomainController=NERR_BASE+593;
    NERR_DefaultJoinRequired=NERR_BASE+594;
    NERR_InvalidWorkgroupName=NERR_BASE+595;
    NERR_NameUsesIncompatibleCodePage=NERR_BASE+596;
    NERR_ComputerAccountNotFound=NERR_BASE+597;
    MAX_NERR=NERR_BASE+899;
    CNLEN=15;// Computer name length
    LM20_CNLEN=15;// LM 2.0 Computer name length
    DNLEN=CNLEN;// Maximum domain name length
    LM20_DNLEN=LM20_CNLEN;// LM 2.0 Maximum domain name length
    UNCLEN=(CNLEN+2);// UNC computer name length
    LM20_UNCLEN=(LM20_CNLEN+2);// LM 2.0 UNC computer name length
    NNLEN=80;// Net name length (share name)
    LM20_NNLEN=12;// LM 2.0 Net name length
    RMLEN=(UNCLEN+1+NNLEN);// Max remote name length
    LM20_RMLEN=(LM20_UNCLEN+1+LM20_NNLEN);// LM 2.0 Max remote name length
    SNLEN=80;// Service name length
    LM20_SNLEN=15;// LM 2.0 Service name length
    STXTLEN=256;// Service text length
    LM20_STXTLEN=63;// LM 2.0 Service text length
    PATHLEN=256;// Max. path (not including drive name)
    LM20_PATHLEN=256;// LM 2.0 Max. path
    DEVLEN=80;// Device name length
    LM20_DEVLEN=8;// LM 2.0 Device name length
    EVLEN=16;// Event name length
    UNLEN=256;// Maximum user name length
    LM20_UNLEN=20;// LM 2.0 Maximum user name length
    GNLEN=UNLEN;// Group name
    LM20_GNLEN=LM20_UNLEN;// LM 2.0 Group name
    PWLEN=256;// Maximum password length
    LM20_PWLEN=14;// LM 2.0 Maximum password length
    SHPWLEN=8;// Share password length (bytes)
    CLTYPE_LEN=12;// Length of client type string
    MAXCOMMENTSZ=256;// Multipurpose comment length
    LM20_MAXCOMMENTSZ=48;// LM 2.0 Multipurpose comment length
    QNLEN=NNLEN;// Queue name maximum length
    LM20_QNLEN=LM20_NNLEN;// LM 2.0 Queue name maximum length
    ALERTSZ=128;// size of alert string in server
    MAXDEVENTRIES=sizeof(integer)*8;// Max number of device entries
    NETBIOS_NAME_LEN=16;// NetBIOS net name (bytes)
    MAX_PREFERRED_LENGTH=DWORD(-1);
    CRYPT_KEY_LEN=7;
    CRYPT_TXT_LEN=8;
    ENCRYPTED_PWLEN=16;
    SESSION_PWLEN=24;
    SESSION_CRYPT_KLEN=21;
    PARMNUM_ALL=0;
    PARM_ERROR_UNKNOWN=DWORD(-1);
    PARM_ERROR_NONE=0;
    PARMNUM_BASE_INFOLEVEL=1000;
    PLATFORM_ID_DOS=300;
    PLATFORM_ID_OS2=400;
    PLATFORM_ID_NT=500;
    PLATFORM_ID_OSF=600;
    PLATFORM_ID_VMS=700;
    MIN_LANMAN_MESSAGE_ID=NERR_BASE;
    MAX_LANMAN_MESSAGE_ID=5799;
    UF_SCRIPT=$0001;
    UF_ACCOUNTDISABLE=$0002;
    UF_HOMEDIR_REQUIRED=$0008;
    UF_LOCKOUT=$0010;
    UF_PASSWD_NOTREQD=$0020;
    UF_PASSWD_CANT_CHANGE=$0040;
    UF_ENCRYPTED_TEXT_PASSWORD_ALLOWED=$0080;
    UF_TEMP_DUPLICATE_ACCOUNT=$0100;
    UF_NORMAL_ACCOUNT=$0200;
    UF_INTERDOMAIN_TRUST_ACCOUNT=$0800;
    UF_WORKSTATION_TRUST_ACCOUNT=$1000;
    UF_SERVER_TRUST_ACCOUNT=$2000;
    UF_MACHINE_ACCOUNT_MASK=(UF_INTERDOMAIN_TRUST_ACCOUNT OR UF_WORKSTATION_TRUST_ACCOUNT OR UF_SERVER_TRUST_ACCOUNT);
    UF_ACCOUNT_TYPE_MASK=(UF_TEMP_DUPLICATE_ACCOUNT OR UF_NORMAL_ACCOUNT OR UF_INTERDOMAIN_TRUST_ACCOUNT OR UF_WORKSTATION_TRUST_ACCOUNT OR UF_SERVER_TRUST_ACCOUNT);
    UF_DONT_EXPIRE_PASSWD=$10000;
    UF_MNS_LOGON_ACCOUNT=$20000;
    UF_SMARTCARD_REQUIRED=$40000;
    UF_TRUSTED_FOR_DELEGATION=$80000;
    UF_NOT_DELEGATED=$100000;
    UF_USE_DES_KEY_ONLY=$200000;
    UF_DONT_REQUIRE_PREAUTH=$400000;
    UF_SETTABLE_BITS=(UF_SCRIPT OR UF_ACCOUNTDISABLE OR UF_LOCKOUT OR UF_HOMEDIR_REQUIRED OR UF_PASSWD_NOTREQD OR UF_PASSWD_CANT_CHANGE OR UF_ACCOUNT_TYPE_MASK OR UF_DONT_EXPIRE_PASSWD OR UF_MNS_LOGON_ACCOUNT OR UF_ENCRYPTED_TEXT_PASSWORD_ALLOWED OR UF_SMARTCARD_REQUIRED OR UF_TRUSTED_FOR_DELEGATION OR UF_NOT_DELEGATED OR UF_USE_DES_KEY_ONLY OR UF_DONT_REQUIRE_PREAUTH);
    FILTER_TEMP_DUPLICATE_ACCOUNT=($0001);
    FILTER_NORMAL_ACCOUNT=($0002);
//FILTER_PROXY_ACCOUNT=(0x0004);
    FILTER_INTERDOMAIN_TRUST_ACCOUNT=($0008);
    FILTER_WORKSTATION_TRUST_ACCOUNT=($0010);
    FILTER_SERVER_TRUST_ACCOUNT=($0020);
    LG_INCLUDE_INDIRECT=($0001);
    AF_OP_PRINT=$1;
    AF_OP_COMM=$2;
    AF_OP_SERVER=$4;
    AF_OP_ACCOUNTS=$8;
    AF_SETTABLE_BITS=(AF_OP_PRINT OR AF_OP_COMM OR AF_OP_SERVER OR AF_OP_ACCOUNTS);
    UAS_ROLE_STANDALONE=0;
    UAS_ROLE_MEMBER=1;
    UAS_ROLE_BACKUP=2;
    UAS_ROLE_PRIMARY=3;
    USER_NAME_PARMNUM=1;
    USER_PASSWORD_PARMNUM=3;
    USER_PASSWORD_AGE_PARMNUM=4;
    USER_PRIV_PARMNUM=5;
    USER_HOME_DIR_PARMNUM=6;
    USER_COMMENT_PARMNUM=7;
    USER_FLAGS_PARMNUM=8;
    USER_SCRIPT_PATH_PARMNUM=9;
    USER_AUTH_FLAGS_PARMNUM=10;
    USER_FULL_NAME_PARMNUM=11;
    USER_USR_COMMENT_PARMNUM=12;
    USER_PARMS_PARMNUM=13;
    USER_WORKSTATIONS_PARMNUM=14;
    USER_LAST_LOGON_PARMNUM=15;
    USER_LAST_LOGOFF_PARMNUM=16;
    USER_ACCT_EXPIRES_PARMNUM=17;
    USER_MAX_STORAGE_PARMNUM=18;
    USER_UNITS_PER_WEEK_PARMNUM=19;
    USER_LOGON_HOURS_PARMNUM=20;
    USER_PAD_PW_COUNT_PARMNUM=21;
    USER_NUM_LOGONS_PARMNUM=22;
    USER_LOGON_SERVER_PARMNUM=23;
    USER_COUNTRY_CODE_PARMNUM=24;
    USER_CODE_PAGE_PARMNUM=25;
    USER_PRIMARY_GROUP_PARMNUM=51;
    USER_PROFILE=52;// ?? Delete when convenient
    USER_PROFILE_PARMNUM=52;
    USER_HOME_DIR_DRIVE_PARMNUM=53;
    USER_NAME_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_NAME_PARMNUM);
    USER_PASSWORD_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_PASSWORD_PARMNUM);
    USER_PASSWORD_AGE_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_PASSWORD_AGE_PARMNUM);
    USER_PRIV_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_PRIV_PARMNUM);
    USER_HOME_DIR_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_HOME_DIR_PARMNUM);
    USER_COMMENT_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_COMMENT_PARMNUM);
    USER_FLAGS_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_FLAGS_PARMNUM);
    USER_SCRIPT_PATH_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_SCRIPT_PATH_PARMNUM);
    USER_AUTH_FLAGS_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_AUTH_FLAGS_PARMNUM);
    USER_FULL_NAME_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_FULL_NAME_PARMNUM);
    USER_USR_COMMENT_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_USR_COMMENT_PARMNUM);
    USER_PARMS_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_PARMS_PARMNUM);
    USER_WORKSTATIONS_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_WORKSTATIONS_PARMNUM);
    USER_LAST_LOGON_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_LAST_LOGON_PARMNUM);
    USER_LAST_LOGOFF_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_LAST_LOGOFF_PARMNUM);
    USER_ACCT_EXPIRES_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_ACCT_EXPIRES_PARMNUM);
    USER_MAX_STORAGE_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_MAX_STORAGE_PARMNUM);
    USER_UNITS_PER_WEEK_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_UNITS_PER_WEEK_PARMNUM);
    USER_LOGON_HOURS_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_LOGON_HOURS_PARMNUM);
    USER_PAD_PW_COUNT_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_PAD_PW_COUNT_PARMNUM);
    USER_NUM_LOGONS_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_NUM_LOGONS_PARMNUM);
    USER_LOGON_SERVER_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_LOGON_SERVER_PARMNUM);
    USER_COUNTRY_CODE_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_COUNTRY_CODE_PARMNUM);
    USER_CODE_PAGE_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_CODE_PAGE_PARMNUM);
    USER_PRIMARY_GROUP_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_PRIMARY_GROUP_PARMNUM);
    USER_HOME_DIR_DRIVE_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+USER_HOME_DIR_DRIVE_PARMNUM);
    NULL_USERSETINFO_PASSWD='              ';//14 chars
    TIMEQ_FOREVER=(DWORD(-1));
    USER_MAXSTORAGE_UNLIMITED=(DWORD(-1));
    USER_NO_LOGOFF=(DWORD(-1));
    UNITS_PER_DAY=24;
    UNITS_PER_WEEK=UNITS_PER_DAY*7;
    USER_PRIV_MASK=$3;
    USER_PRIV_GUEST=0;
    USER_PRIV_USER=1;
    USER_PRIV_ADMIN=2;
    MAX_PASSWD_LEN=PWLEN;
    DEF_MIN_PWLEN=6;
    DEF_PWUNIQUENESS=5;
    DEF_MAX_PWHIST=8;
    DEF_MAX_PWAGE=TIMEQ_FOREVER;// forever
    DEF_MIN_PWAGE=DWORD(0);// 0 days
    DEF_FORCE_LOGOFF=DWORD($FFFFFFFF);// never
    DEF_MAX_BADPW=0;// no limit
    ONE_DAY=DWORD(01*24*3600);// 01 day
    VALIDATED_LOGON=0;
    PASSWORD_EXPIRED=2;
    NON_VALIDATED_LOGON=3;
    VALID_LOGOFF=1;
    MODALS_MIN_PASSWD_LEN_PARMNUM=1;
    MODALS_MAX_PASSWD_AGE_PARMNUM=2;
    MODALS_MIN_PASSWD_AGE_PARMNUM=3;
    MODALS_FORCE_LOGOFF_PARMNUM=4;
    MODALS_PASSWD_HIST_LEN_PARMNUM=5;
    MODALS_ROLE_PARMNUM=6;
    MODALS_PRIMARY_PARMNUM=7;
    MODALS_DOMAIN_NAME_PARMNUM=8;
    MODALS_DOMAIN_ID_PARMNUM=9;
    MODALS_LOCKOUT_DURATION_PARMNUM=10;
    MODALS_LOCKOUT_OBSERVATION_WINDOW_PARMNUM=11;
    MODALS_LOCKOUT_THRESHOLD_PARMNUM=12;
    MODALS_MIN_PASSWD_LEN_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+MODALS_MIN_PASSWD_LEN_PARMNUM);
    MODALS_MAX_PASSWD_AGE_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+MODALS_MAX_PASSWD_AGE_PARMNUM);
    MODALS_MIN_PASSWD_AGE_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+MODALS_MIN_PASSWD_AGE_PARMNUM);
    MODALS_FORCE_LOGOFF_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+MODALS_FORCE_LOGOFF_PARMNUM);
    MODALS_PASSWD_HIST_LEN_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+MODALS_PASSWD_HIST_LEN_PARMNUM);
    MODALS_ROLE_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+MODALS_ROLE_PARMNUM);
    MODALS_PRIMARY_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+MODALS_PRIMARY_PARMNUM);
    MODALS_DOMAIN_NAME_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+MODALS_DOMAIN_NAME_PARMNUM);
    MODALS_DOMAIN_ID_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+MODALS_DOMAIN_ID_PARMNUM);
    GROUPIDMASK=$8000;// MSB set if uid refers
    GROUP_SPECIALGRP_USERS='USERS';
    GROUP_SPECIALGRP_ADMINS='ADMINS';
    GROUP_SPECIALGRP_GUESTS='GUESTS';
    GROUP_SPECIALGRP_LOCAL='LOCA';
    GROUP_ALL_PARMNUM=0;
    GROUP_NAME_PARMNUM=1;
    GROUP_COMMENT_PARMNUM=2;
    GROUP_ATTRIBUTES_PARMNUM=3;
    GROUP_ALL_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+GROUP_ALL_PARMNUM);
    GROUP_NAME_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+GROUP_NAME_PARMNUM);
    GROUP_COMMENT_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+GROUP_COMMENT_PARMNUM);
    GROUP_ATTRIBUTES_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+GROUP_ATTRIBUTES_PARMNUM);
    LOCALGROUP_NAME_PARMNUM=1;
    LOCALGROUP_COMMENT_PARMNUM=2;
    NETLOGON_CONTROL_QUERY=1;// No-op: just query
    NETLOGON_CONTROL_REPLICATE=2;// Force replicate on BDC
    NETLOGON_CONTROL_SYNCHRONIZE=3;// Force synchronize on BDC
    NETLOGON_CONTROL_PDC_REPLICATE=4;// Force PDC to broadcast change
    NETLOGON_CONTROL_REDISCOVER=5;// Force to re-discover trusted domain DCs
    NETLOGON_CONTROL_TC_QUERY=6;// Query status of specified trusted channel status
    NETLOGON_CONTROL_TRANSPORT_NOTIFY=7;// Notify netlogon that a new transport has come online
    NETLOGON_CONTROL_FIND_USER=8;// Find named user in a trusted domain
    NETLOGON_CONTROL_CHANGE_PASSWORD=9;// Change machine password on a secure channel to a
    NETLOGON_CONTROL_UNLOAD_NETLOGON_DLL=$FFFB;
    NETLOGON_CONTROL_BACKUP_CHANGE_LOG=$FFFC;
    NETLOGON_CONTROL_TRUNCATE_LOG=$FFFD;
    NETLOGON_CONTROL_SET_DBFLAG=$FFFE;
    NETLOGON_CONTROL_BREAKPOINT=$FFFF;
    NETLOGON_REPLICATION_NEEDED=$01;// Database is out of date
    NETLOGON_REPLICATION_IN_PROGRESS=$02;// Replication is happening now
    NETLOGON_FULL_SYNC_REPLICATION=$04;// full sync replication required/progress
    NETLOGON_REDO_NEEDED=$08;// Redo of previous replication needed
    NETLOGON_HAS_IP=$10;// The trusted domain DC has an IP address
    NETLOGON_HAS_TIMESERV=$20;// The trusted domain DC runs the Windows Time
    WKSTA_PLATFORM_ID_PARMNUM=100;
    WKSTA_COMPUTERNAME_PARMNUM=1;
    WKSTA_LANGROUP_PARMNUM=2;
    WKSTA_VER_MAJOR_PARMNUM=4;
    WKSTA_VER_MINOR_PARMNUM=5;
    WKSTA_LOGGED_ON_USERS_PARMNUM=6;
    WKSTA_LANROOT_PARMNUM=7;
    WKSTA_LOGON_DOMAIN_PARMNUM=8;
    WKSTA_LOGON_SERVER_PARMNUM=9;
    WKSTA_CHARWAIT_PARMNUM=10;// Supported by down-level.
    WKSTA_CHARTIME_PARMNUM=11;// Supported by down-level.
    WKSTA_CHARCOUNT_PARMNUM=12;// Supported by down-level.
    WKSTA_KEEPCONN_PARMNUM=13;
    WKSTA_KEEPSEARCH_PARMNUM=14;
    WKSTA_MAXCMDS_PARMNUM=15;
    WKSTA_NUMWORKBUF_PARMNUM=16;
    WKSTA_MAXWRKCACHE_PARMNUM=17;
    WKSTA_SESSTIMEOUT_PARMNUM=18;
    WKSTA_SIZERROR_PARMNUM=19;
    WKSTA_NUMALERTS_PARMNUM=20;
    WKSTA_NUMSERVICES_PARMNUM=21;
    WKSTA_NUMCHARBUF_PARMNUM=22;
    WKSTA_SIZCHARBUF_PARMNUM=23;
    WKSTA_ERRLOGSZ_PARMNUM=27;// Supported by down-level.
    WKSTA_PRINTBUFTIME_PARMNUM=28;// Supported by down-level.
    WKSTA_SIZWORKBUF_PARMNUM=29;
    WKSTA_MAILSLOTS_PARMNUM=30;
    WKSTA_NUMDGRAMBUF_PARMNUM=31;
    WKSTA_WRKHEURISTICS_PARMNUM=32;// Supported by down-level.
    WKSTA_MAXTHREADS_PARMNUM=33;
    WKSTA_LOCKQUOTA_PARMNUM=41;
    WKSTA_LOCKINCREMENT_PARMNUM=42;
    WKSTA_LOCKMAXIMUM_PARMNUM=43;
    WKSTA_PIPEINCREMENT_PARMNUM=44;
    WKSTA_PIPEMAXIMUM_PARMNUM=45;
    WKSTA_DORMANTFILELIMIT_PARMNUM=46;
    WKSTA_CACHEFILETIMEOUT_PARMNUM=47;
    WKSTA_USEOPPORTUNISTICLOCKING_PARMNUM=48;
    WKSTA_USEUNLOCKBEHIND_PARMNUM=49;
    WKSTA_USECLOSEBEHIND_PARMNUM=50;
    WKSTA_BUFFERNAMEDPIPES_PARMNUM=51;
    WKSTA_USELOCKANDREADANDUNLOCK_PARMNUM=52;
    WKSTA_UTILIZENTCACHING_PARMNUM=53;
    WKSTA_USERAWREAD_PARMNUM=54;
    WKSTA_USERAWWRITE_PARMNUM=55;
    WKSTA_USEWRITERAWWITHDATA_PARMNUM=56;
    WKSTA_USEENCRYPTION_PARMNUM=57;
    WKSTA_BUFFILESWITHDENYWRITE_PARMNUM=58;
    WKSTA_BUFFERREADONLYFILES_PARMNUM=59;
    WKSTA_FORCECORECREATEMODE_PARMNUM=60;
    WKSTA_USE512BYTESMAXTRANSFER_PARMNUM=61;
    WKSTA_READAHEADTHRUPUT_PARMNUM=62;
    WKSTA_OTH_DOMAINS_PARMNUM=101;
    TRANSPORT_QUALITYOFSERVICE_PARMNUM=201;
    TRANSPORT_NAME_PARMNUM=202;
    REPL_ROLE_EXPORT=1;
    REPL_ROLE_IMPORT=2;
    REPL_ROLE_BOTH=3;
    REPL_INTERVAL_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+0);
    REPL_PULSE_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+1);
    REPL_GUARDTIME_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+2);
    REPL_RANDOM_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+3);
    REPL_INTEGRITY_FILE=1;
    REPL_INTEGRITY_TREE=2;
    REPL_EXTENT_FILE=1;
    REPL_EXTENT_TREE=2;
    REPL_EXPORT_INTEGRITY_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+0);
    REPL_EXPORT_EXTENT_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+1);
    REPL_UNLOCK_NOFORCE=0;
    REPL_UNLOCK_FORCE=1;
    REPL_STATE_OK=0;
    REPL_STATE_NO_MASTER=1;
    REPL_STATE_NO_SYNC=2;
    REPL_STATE_NEVER_REPLICATED=3;
    PERM_FILE_READ=$1;// user has read access
    PERM_FILE_WRITE=$2;// user has write access
    PERM_FILE_CREATE=$4;// user has create access
    SHARE_NETNAME_PARMNUM=1;
    SHARE_TYPE_PARMNUM=3;
    SHARE_REMARK_PARMNUM=4;
    SHARE_PERMISSIONS_PARMNUM=5;
    SHARE_MAX_USES_PARMNUM=6;
    SHARE_CURRENT_USES_PARMNUM=7;
    SHARE_PATH_PARMNUM=8;
    SHARE_PASSWD_PARMNUM=9;
    SHARE_FILE_SD_PARMNUM=501;
    SHARE_REMARK_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+SHARE_REMARK_PARMNUM);
    SHARE_MAX_USES_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+SHARE_MAX_USES_PARMNUM);
    SHARE_FILE_SD_INFOLEVEL=(PARMNUM_BASE_INFOLEVEL+SHARE_FILE_SD_PARMNUM);
    SHI1_NUM_ELEMENTS=4;
    SHI2_NUM_ELEMENTS=10;
    STYPE_DISKTREE=0;
    STYPE_PRINTQ=1;
    STYPE_DEVICE=2;
    STYPE_IPC=3;
    STYPE_SPECIAL=$80000000;
    SHI_USES_UNLIMITED=DWORD(-1);
    SHI1005_FLAGS_DFS=$01;// Share is in the DFS
    SHI1005_FLAGS_DFS_ROOT=$02;// Share is root of DFS
    CSC_MASK=$30;// Used to mask off the following states
    CSC_CACHE_MANUAL_REINT=$00;// No automatic file by file reintegration
    CSC_CACHE_AUTO_REINT=$10;// File by file reintegration is OK
    CSC_CACHE_VDO=$20;// no need to flow opens
    CSC_CACHE_NONE=$30;// no CSC for this share
    SHI1005_VALID_FLAGS_SET=CSC_MASK;
    SESS_GUEST=$00000001;// session is logged on as a guest
    SESS_NOENCRYPTION=$00000002;// session is not using encryption
    SESI1_NUM_ELEMENTS=8;
    SESI2_NUM_ELEMENTS=9;

