{Note, this collection of LanManager functions and structures is intended
 for exclusive use on Windows NT platforms (WNT/W2K). Thus I ommitted
 the functions which were marked as either obsolete or W9X/WME only in
 the MS Platform SDKs 4/2000 and 7/2000

 Left-outs:
           Access Functions         only Win95/98
           Audit Functions          for 16 bit compat.: use event logging
           Configuration Functions
           Error Logging Functions
           NetService Functions

 Herein are contained several comments which will be marked with PSDK
 which refers to the above mentioned MS Platform SDK 7/2000

 Note, that I decided to make everything dynamically loadable, since I am
 planning to write across-platform applications which will fail to start
 if not supported functions are linked into the EXE

 Note furthermore, that I took almost everything from the PSDK
 documentation instead from the INCLUDE files. It is the same work but
 better documented ;-)  ......

 HISTORY ;-))
 After one day of hard work I decided to also include the W2K functions
 and structures (initially I intended to convert only the WNT40 part)
 It does not matter anyway, which functions we try to get ... it's only
 true, that, if we try to call functions which still point to NIL
 we may hose up the NT machine ... I'm not yet sure about this ...

 Introduced the symbols:  NT40 for version 4.0 and above
                          NT50 for version 5.0, also known as W2K and above
                          NTless40 for versions less than 4.0 [MS ommitted
                                              some of the functions in W2k]

 I am now already working 6 full days on that ... IT SUCKS!!! ;o)


 ALL THE STUFF HERE IS GoPyright (G) 2000 by -=Assarbad [GoP]=-
 (
  which means you may do whatever you want to do with that.
  The only thing! I AM NOT RESPONSIBLE FOR ANYTHING OF WHAT MAY
  RESULT FROM THE USE OF THIS! SO DON'T BLAME ME!

  I RESERVE THE RIGHT TO CHANGE (my original of) THE SOURCE, HOWEVER.
 )
}

UNIT NT_LMAPI;
INTERFACE

USES windows;

{$DEFINE NT40}
{$DEFINE NTless40}
{DEFINE NT50}
{$DEFINE LM20_WORKSTATION_STATISTICS}

FUNCTION ALERT_OTHER_INFO(x:Pointer):Pointer;
FUNCTION ALERT_VAR_DATA(CONST p):Pointer;

{$INCLUDE NT_LMAPI.CONST.PAS}
{$INCLUDE NT_LMAPI.TYPES.PAS}
{$INCLUDE NT_LMAPI.FUNCS.PAS}

CONST
    dllname='NetAPI32.DLL';

VAR
//the NETAPI32.DLL handle ... since we do everything dynamically
//we have to load the DLL manually ;-)
    hNetAPI32_DLL:DWORD=0;
    Iloaded:boolean=false;

//Alert Functions
    NetAlertRaise:TNetAlertRaise=NIL;//NT31+
    NetAlertRaiseEx:TNetAlertRaiseEx=NIL;//NT31+

//ApiBuffer Functions
    NetApiBufferAllocate:TNetApiBufferAllocate=NIL;//NT31+
    NetApiBufferFree:TNetApiBufferFree=NIL;//NT31+
    NetApiBufferReallocate:TNetApiBufferReallocate=NIL;//NT31+
    NetApiBufferSize:TNetApiBufferSize=NIL;//NT31+

{//Directory Service Functions (W2K+)
    NetGetJoinableOUs:TNetGetJoinableOUs=NIL;//NT50+
    NetGetJoinInformation:TNetGetJoinInformation=NIL;//NT50+
    NetJoinDomain:TNetJoinDomain=NIL;//NT50+
    NetRenameMachineInDomain:TNetRenameMachineInDomain=NIL;//NT50+
    NetUnjoinDomain:TNetUnjoinDomain=NIL;//NT50+
    NetValidateName:TNetValidateName=NIL;//NT50+
}

//Distributed File System (Dfs) Functions
{$IFDEF NT40}
    NetDfsAdd:TNetDfsAdd=NIL;//NT40+
    NetDfsEnum:TNetDfsEnum=NIL;//NT40+
    NetDfsGetInfo:TNetDfsGetInfo=NIL;//NT40+
    NetDfsRemove:TNetDfsRemove=NIL;//NT40+
    NetDfsSetInfo:TNetDfsSetInfo=NIL;//NT40+
{$ENDIF}
{$IFDEF NT50}
    NetDfsAddFtRoot:TNetDfsAddFtRoot=NIL;//NT50+
    NetDfsAddStdRoot:TNetDfsAddStdRoot=NIL;//NT50+
    NetDfsAddStdRootForced:TNetDfsAddStdRootForced=NIL;//NT50+
    NetDfsGetClientInfo:TNetDfsGetClientInfo=NIL;//NT50+
    NetDfsManagerInitialize:TNetDfsManagerInitialize=NIL;//NT50+
    NetDfsRemoveFtRoot:TNetDfsRemoveFtRoot=NIL;//NT50+
    NetDfsRemoveFtRootForced:TNetDfsRemoveFtRootForced=NIL;//NT50+
    NetDfsRemoveStdRoot:TNetDfsRemoveStdRoot=NIL;//NT50+
    NetDfsSetClientInfo:TNetDfsSetClientInfo=NIL;//NT50+
{$ENDIF}

//Get Functions
    NetGetAnyDCName:TNetGetAnyDCName=NIL;//NT31+
    NetGetDCName:TNetGetDCName=NIL;//NT31+
    NetGetDisplayInformationIndex:TNetGetDisplayInformationIndex=NIL;//NT31+
    NetQueryDisplayInformation:TNetQueryDisplayInformation=NIL;//NT31+

//Group Functions
    NetGroupAdd:TNetGroupAdd=NIL;//NT31+
    NetGroupAddUser:TNetGroupAddUser=NIL;//NT31+
    NetGroupDel:TNetGroupDel=NIL;//NT31+
    NetGroupDelUser:TNetGroupDelUser=NIL;//NT31+
    NetGroupEnum:TNetGroupEnum=NIL;//NT31+
    NetGroupGetInfo:TNetGroupGetInfo=NIL;//NT31+
    NetGroupGetUsers:TNetGroupGetUsers=NIL;//NT31+
    NetGroupSetInfo:TNetGroupSetInfo=NIL;//NT31+
    NetGroupSetUsers:TNetGroupSetUsers=NIL;//NT31+

{$IFDEF NT50}
    NetJoinDomain:TNetJoinDomain=NIL;//NT50+
    NetUnjoinDomain:TNetUnjoinDomain=NIL;//NT50+
    NetRenameMachineInDomain:TNetRenameMachineInDomain=NIL;//NT50+
    NetValidateName:TNetValidateName=NIL;//NT50+
    NetGetJoinInformation:TNetGetJoinInformation=NIL;//NT50+
    NetGetJoinableOUs:TNetGetJoinableOUs=NIL;//NT50+
{$ENDIF}

//Local Group Functions
    NetLocalGroupAdd:TNetLocalGroupAdd=NIL;//NT31+
    NetLocalGroupAddMembers:TNetLocalGroupAddMembers=NIL;//NT31+
    NetLocalGroupDel:TNetLocalGroupDel=NIL;//NT31+
    NetLocalGroupDelMembers:TNetLocalGroupDelMembers=NIL;//NT31+
    NetLocalGroupEnum:TNetLocalGroupEnum=NIL;//NT31+
    NetLocalGroupGetInfo:TNetLocalGroupGetInfo=NIL;//NT31+
    NetLocalGroupGetMembers:TNetLocalGroupGetMembers=NIL;//NT31+
    NetLocalGroupSetInfo:TNetLocalGroupSetInfo=NIL;//NT31+
    NetLocalGroupSetMembers:TNetLocalGroupSetMembers=NIL;//NT31+

//Message Functions
    NetMessageBufferSend:TNetMessageBufferSend=NIL;//NT31+
    NetMessageNameAdd:TNetMessageNameAdd=NIL;//NT31+
    NetMessageNameDel:TNetMessageNameDel=NIL;//NT31+
    NetMessageNameEnum:TNetMessageNameEnum=NIL;//NT31+
    NetMessageNameGetInfo:TNetMessageNameGetInfo=NIL;//NT31+

//NetFile Functions
    NetFileClose:TNetFileClose=NIL;//NT31+
    NetFileEnum:TNetFileEnum=NIL;//NT31+
    NetFileGetInfo:TNetFileGetInfo=NIL;//NT31+

//Remote Utility Functions
    NetRemoteTOD:TNetRemoteTOD=NIL;//NT31+
{$IFDEF NT40}
    NetRemoteComputerSupports:TNetRemoteComputerSupports=NIL;//NT40+
{$ENDIF}

//Replicator Functions
             //note, that W2K does not support these functions
{$IFDEF NTless40}
    NetReplExportDirAdd:TNetReplExportDirAdd=NIL;//NT40-
    NetReplExportDirDel:TNetReplExportDirDel=NIL;//NT40-
    NetReplExportDirEnum:TNetReplExportDirEnum=NIL;//NT40-
    NetReplExportDirGetInfo:TNetReplExportDirGetInfo=NIL;//NT40-
    NetReplExportDirLock:TNetReplExportDirLock=NIL;//NT40-
    NetReplExportDirSetInfo:TNetReplExportDirSetInfo=NIL;//NT40-
    NetReplExportDirUnlock:TNetReplExportDirUnlock=NIL;//NT40-
    NetReplGetInfo:TNetReplGetInfo=NIL;//NT40-
    NetReplImportDirAdd:TNetReplImportDirAdd=NIL;//NT40-
    NetReplImportDirDel:TNetReplImportDirDel=NIL;//NT40-
    NetReplImportDirEnum:TNetReplImportDirEnum=NIL;//NT40-
    NetReplImportDirGetInfo:TNetReplImportDirGetInfo=NIL;//NT40-
    NetReplImportDirLock:TNetReplImportDirLock=NIL;//NT40-
    NetReplImportDirUnlock:TNetReplImportDirUnlock=NIL;//NT40-
    NetReplSetInfo:TNetReplSetInfo=NIL;//NT40-
{$ENDIF}

//Schedule Functions
    NetScheduleJobAdd:TNetScheduleJobAdd=NIL;//NT31+
    NetScheduleJobDel:TNetScheduleJobDel=NIL;//NT31+
    NetScheduleJobEnum:TNetScheduleJobEnum=NIL;//NT31+
    NetScheduleJobGetInfo:TNetScheduleJobGetInfo=NIL;//NT31+

//Server Functions
    NetServerDiskEnum:TNetServerDiskEnum=NIL;//NT31+
    NetServerEnum:TNetServerEnum=NIL;//NT31+
    NetServerGetInfo:TNetServerGetInfo=NIL;//NT31+
    NetServerSetInfo:TNetServerSetInfo=NIL;//NT31+

//Server and Workstation Transport Functions
    NetServerTransportAdd:TNetServerTransportAdd=NIL;//NT31+
    NetServerTransportDel:TNetServerTransportDel=NIL;//NT31+
    NetServerTransportEnum:TNetServerTransportEnum=NIL;//NT31+
    NetWkstaTransportEnum:TNetWkstaTransportEnum=NIL;//NT31+
{$IFDEF NT40}
    NetServerComputerNameAdd:TNetServerComputerNameAdd=NIL;//NT40+
    NetServerComputerNameDel:TNetServerComputerNameDel=NIL;//NT40+
    NetServerTransportAddEx:TNetServerTransportAddEx=NIL;//NT40+
{$ENDIF}
             //note, that W2K does not support these functions
{$IFDEF NTless40}
    NetWkstaTransportAdd:TNetWkstaTransportAdd=NIL;//NT40-
    NetWkstaTransportDel:TNetWkstaTransportDel=NIL;//NT40-
{$ENDIF}

//Session Functions
    NetSessionDel:TNetSessionDel=NIL;//NT31+
    NetSessionEnum:TNetSessionEnum=NIL;//NT31+
    NetSessionGetInfo:TNetSessionGetInfo=NIL;//NT31+

//Share Functions
    NetConnectionEnum:TNetConnectionEnum=NIL;//NT31+
    NetShareAdd:TNetShareAdd=NIL;//NT31+
    NetShareCheck:TNetShareCheck=NIL;//NT31+
    NetShareDel:TNetShareDel=NIL;//NT31+
    NetShareEnum:TNetShareEnum=NIL;//NT31+
    NetShareGetInfo:TNetShareGetInfo=NIL;//NT31+
    NetShareSetInfo:TNetShareSetInfo=NIL;//NT31+

//Statistics Function
    NetStatisticsGet:TNetStatisticsGet=NIL;//NT31+

//Use Functions
    NetUseAdd:TNetUseAdd=NIL;//NT31+
    NetUseDel:TNetUseDel=NIL;//NT31+
    NetUseEnum:TNetUseEnum=NIL;//NT31+
    NetUseGetInfo:TNetUseGetInfo=NIL;//NT31+

//User Functions
    NetUserAdd:TNetUserAdd=NIL;//NT31+
    NetUserChangePassword:TNetUserChangePassword=NIL;//NT31+
    NetUserDel:TNetUserDel=NIL;//NT31+
    NetUserEnum:TNetUserEnum=NIL;//NT31+
    NetUserGetGroups:TNetUserGetGroups=NIL;//NT31+
    NetUserGetInfo:TNetUserGetInfo=NIL;//NT31+
    NetUserGetLocalGroups:TNetUserGetLocalGroups=NIL;//NT31+
    NetUserSetGroups:TNetUserSetGroups=NIL;//NT31+
    NetUserSetInfo:TNetUserSetInfo=NIL;//NT31+

//User Modals Functions
    NetUserModalsGet:TNetUserModalsGet=NIL;//NT31+
    NetUserModalsSet:TNetUserModalsSet=NIL;//NT31+

//Workstation and Workstation User Functions
    NetWkstaGetInfo:TNetWkstaGetInfo=NIL;//NT31+
    NetWkstaSetInfo:TNetWkstaSetInfo=NIL;//NT31+
    NetWkstaUserGetInfo:TNetWkstaUserGetInfo=NIL;//NT31+
    NetWkstaUserSetInfo:TNetWkstaUserSetInfo=NIL;//NT31+
    NetWkstaUserEnum:TNetWkstaUserEnum=NIL;//NT31+

IMPLEMENTATION
{$INCLUDE NT_LMAPI.MACRO.PAS}

PROCEDURE LoadLib;
BEGIN
     {now it's possible to implement the OS checking ;-)  }
    hNetAPI32_DLL:=GetModuleHandle(dllname);
    IF hNetAPI32_DLL=0 THEN BEGIN
        hNetAPI32_DLL:=GetModuleHandle(dllname);
        IF hNetAPI32_DLL<>0 THEN Iloaded:=true;
    END;
    IF hNetAPI32_DLL<>0 THEN BEGIN
              //Alert Functions
        @NetAlertRaise:=GetProcAddress(hNetAPI32_DLL, 'NetAlertRaise');
        @NetAlertRaiseEx:=GetProcAddress(hNetAPI32_DLL, 'NetAlertRaiseEx');

              //ApiBuffer Functions
        @NetApiBufferAllocate:=GetProcAddress(hNetAPI32_DLL, 'NetApiBufferAllocate');
        @NetApiBufferFree:=GetProcAddress(hNetAPI32_DLL, 'NetApiBufferFree');
        @NetApiBufferReallocate:=GetProcAddress(hNetAPI32_DLL, 'NetApiBufferReallocate');
        @NetApiBufferSize:=GetProcAddress(hNetAPI32_DLL, 'NetApiBufferSize');

              //Distributed File System (Dfs) Functions
{$IFDEF NT40}
        @NetDfsAdd:=GetProcAddress(hNetAPI32_DLL, 'NetDfsAdd');
        @NetDfsEnum:=GetProcAddress(hNetAPI32_DLL, 'NetDfsEnum');
        @NetDfsGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetDfsGetInfo');
        @NetDfsRemove:=GetProcAddress(hNetAPI32_DLL, 'NetDfsRemove');
        @NetDfsSetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetDfsSetInfo');
{$ENDIF}
{$IFDEF NT50}
        @NetDfsAddFtRoot:=GetProcAddress(hNetAPI32_DLL, 'NetDfsAddFtRoot');
        @NetDfsAddStdRoot:=GetProcAddress(hNetAPI32_DLL, 'NetDfsAddStdRoot');
        @NetDfsAddStdRootForced:=GetProcAddress(hNetAPI32_DLL, 'NetDfsAddStdRootForced');
        @NetDfsGetClientInfo:=GetProcAddress(hNetAPI32_DLL, 'NetDfsGetClientInfo');
        @NetDfsManagerInitialize:=GetProcAddress(hNetAPI32_DLL, 'NetDfsManagerInitialize');
        @NetDfsRemoveFtRoot:=GetProcAddress(hNetAPI32_DLL, 'NetDfsRemoveFtRoot');
        @NetDfsRemoveFtRootForced:=GetProcAddress(hNetAPI32_DLL, 'NetDfsRemoveFtRootForced');
        @NetDfsRemoveStdRoot:=GetProcAddress(hNetAPI32_DLL, 'NetDfsRemoveStdRoot');
        @NetDfsSetClientInfo:=GetProcAddress(hNetAPI32_DLL, 'NetDfsSetClientInfo');
{$ENDIF}

              //Get Functions
        @NetGetAnyDCName:=GetProcAddress(hNetAPI32_DLL, 'NetGetAnyDCName');
        @NetGetDCName:=GetProcAddress(hNetAPI32_DLL, 'NetGetDCName');
        @NetGetDisplayInformationIndex:=GetProcAddress(hNetAPI32_DLL, 'NetGetDisplayInformationIndex');
        @NetQueryDisplayInformation:=GetProcAddress(hNetAPI32_DLL, 'NetQueryDisplayInformation');

              //Group Functions
        @NetGroupAdd:=GetProcAddress(hNetAPI32_DLL, 'NetGroupAdd');
        @NetGroupAddUser:=GetProcAddress(hNetAPI32_DLL, 'NetGroupAddUser');
        @NetGroupDel:=GetProcAddress(hNetAPI32_DLL, 'NetGroupDel');
        @NetGroupDelUser:=GetProcAddress(hNetAPI32_DLL, 'NetGroupDelUser');
        @NetGroupEnum:=GetProcAddress(hNetAPI32_DLL, 'NetGroupEnum');
        @NetGroupGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetGroupGetInfo');
        @NetGroupGetUsers:=GetProcAddress(hNetAPI32_DLL, 'NetGroupGetUsers');
        @NetGroupSetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetGroupSetInfo');
        @NetGroupSetUsers:=GetProcAddress(hNetAPI32_DLL, 'NetGroupSetUsers');

{$IFDEF NT50}
        @NetJoinDomain:=GetProcAddress(hNetAPI32_DLL, 'NetJoinDomain');
        @NetUnjoinDomain:=GetProcAddress(hNetAPI32_DLL, 'NetUnjoinDomain');
        @NetRenameMachineInDomain:=GetProcAddress(hNetAPI32_DLL, 'NetRenameMachineInDomain');
        @NetValidateName:=GetProcAddress(hNetAPI32_DLL, 'NetValidateName');
        @NetGetJoinInformation:=GetProcAddress(hNetAPI32_DLL, 'NetGetJoinInformation');
        @NetGetJoinableOUs:=GetProcAddress(hNetAPI32_DLL, 'NetGetJoinableOUs');
{$ENDIF}

              //Local Group Functions
        @NetLocalGroupAdd:=GetProcAddress(hNetAPI32_DLL, 'NetLocalGroupAdd');
        @NetLocalGroupAddMembers:=GetProcAddress(hNetAPI32_DLL, 'NetLocalGroupAddMembers');
        @NetLocalGroupDel:=GetProcAddress(hNetAPI32_DLL, 'NetLocalGroupDel');
        @NetLocalGroupDelMembers:=GetProcAddress(hNetAPI32_DLL, 'NetLocalGroupDelMembers');
        @NetLocalGroupEnum:=GetProcAddress(hNetAPI32_DLL, 'NetLocalGroupEnum');
        @NetLocalGroupGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetLocalGroupGetInfo');
        @NetLocalGroupGetMembers:=GetProcAddress(hNetAPI32_DLL, 'NetLocalGroupGetMembers');
        @NetLocalGroupSetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetLocalGroupSetInfo');
        @NetLocalGroupSetMembers:=GetProcAddress(hNetAPI32_DLL, 'NetLocalGroupSetMembers');

              //Message Functions
        @NetMessageBufferSend:=GetProcAddress(hNetAPI32_DLL, 'NetMessageBufferSend');
        @NetMessageNameAdd:=GetProcAddress(hNetAPI32_DLL, 'NetMessageNameAdd');
        @NetMessageNameDel:=GetProcAddress(hNetAPI32_DLL, 'NetMessageNameDel');
        @NetMessageNameEnum:=GetProcAddress(hNetAPI32_DLL, 'NetMessageNameEnum');
        @NetMessageNameGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetMessageNameGetInfo');

              //NetFile Functions
        @NetFileClose:=GetProcAddress(hNetAPI32_DLL, 'NetFileClose');
        @NetFileEnum:=GetProcAddress(hNetAPI32_DLL, 'NetFileEnum');
        @NetFileGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetFileGetInfo');

              //Remote Utility Functions
        @NetRemoteComputerSupports:=GetProcAddress(hNetAPI32_DLL, 'NetRemoteComputerSupports');
{$IFDEF NT40}
        @NetRemoteTOD:=GetProcAddress(hNetAPI32_DLL, 'NetRemoteTOD');
{$ENDIF}

              //Replicator Functions
{$IFDEF NTless40}
        @NetReplExportDirAdd:=GetProcAddress(hNetAPI32_DLL, 'NetReplExportDirAdd');
        @NetReplExportDirDel:=GetProcAddress(hNetAPI32_DLL, 'NetReplExportDirDel');
        @NetReplExportDirEnum:=GetProcAddress(hNetAPI32_DLL, 'NetReplExportDirEnum');
        @NetReplExportDirGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetReplExportDirGetInfo');
        @NetReplExportDirLock:=GetProcAddress(hNetAPI32_DLL, 'NetReplExportDirLock');
        @NetReplExportDirSetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetReplExportDirSetInfo');
        @NetReplExportDirUnlock:=GetProcAddress(hNetAPI32_DLL, 'NetReplExportDirUnlock');
        @NetReplGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetReplGetInfo');
        @NetReplImportDirAdd:=GetProcAddress(hNetAPI32_DLL, 'NetReplImportDirAdd');
        @NetReplImportDirDel:=GetProcAddress(hNetAPI32_DLL, 'NetReplImportDirDel');
        @NetReplImportDirEnum:=GetProcAddress(hNetAPI32_DLL, 'NetReplImportDirEnum');
        @NetReplImportDirGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetReplImportDirGetInfo');
        @NetReplImportDirLock:=GetProcAddress(hNetAPI32_DLL, 'NetReplImportDirLock');
        @NetReplImportDirUnlock:=GetProcAddress(hNetAPI32_DLL, 'NetReplImportDirUnlock');
        @NetReplSetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetReplSetInfo');
{$ENDIF}

              //Schedule Functions
        @NetScheduleJobAdd:=GetProcAddress(hNetAPI32_DLL, 'NetScheduleJobAdd');
        @NetScheduleJobDel:=GetProcAddress(hNetAPI32_DLL, 'NetScheduleJobDel');
        @NetScheduleJobEnum:=GetProcAddress(hNetAPI32_DLL, 'NetScheduleJobEnum');
        @NetScheduleJobGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetScheduleJobGetInfo');

              //Server Functions
        @NetServerDiskEnum:=GetProcAddress(hNetAPI32_DLL, 'NetServerDiskEnum');
        @NetServerEnum:=GetProcAddress(hNetAPI32_DLL, 'NetServerEnum');
        @NetServerGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetServerGetInfo');
        @NetServerSetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetServerSetInfo');

              //Server and Workstation Transport Functions
        @NetServerTransportAdd:=GetProcAddress(hNetAPI32_DLL, 'NetServerTransportAdd');
        @NetServerTransportDel:=GetProcAddress(hNetAPI32_DLL, 'NetServerTransportDel');
        @NetServerTransportEnum:=GetProcAddress(hNetAPI32_DLL, 'NetServerTransportEnum');
        @NetWkstaTransportEnum:=GetProcAddress(hNetAPI32_DLL, 'NetWkstaTransportEnum');
{$IFDEF NT40}
        @NetServerComputerNameAdd:=GetProcAddress(hNetAPI32_DLL, 'NetServerComputerNameAdd');
        @NetServerComputerNameDel:=GetProcAddress(hNetAPI32_DLL, 'NetServerComputerNameDel');
        @NetServerTransportAddEx:=GetProcAddress(hNetAPI32_DLL, 'NetServerTransportAddEx');
{$ENDIF}
{$IFDEF NTless40}
             //note, that W2K does not support these functions
        @NetWkstaTransportAdd:=GetProcAddress(hNetAPI32_DLL, 'NetWkstaTransportAdd');
        @NetWkstaTransportDel:=GetProcAddress(hNetAPI32_DLL, 'NetWkstaTransportDel');
{$ENDIF}

              //Session Functions
        @NetSessionEnum:=GetProcAddress(hNetAPI32_DLL, 'NetSessionEnum');
        @NetSessionDel:=GetProcAddress(hNetAPI32_DLL, 'NetSessionDel');
        @NetSessionGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetSessionGetInfo');

              //Share Functions
        @NetConnectionEnum:=GetProcAddress(hNetAPI32_DLL, 'NetConnectionEnum');
        @NetShareAdd:=GetProcAddress(hNetAPI32_DLL, 'NetShareAdd');
        @NetShareCheck:=GetProcAddress(hNetAPI32_DLL, 'NetShareCheck');
        @NetShareDel:=GetProcAddress(hNetAPI32_DLL, 'NetShareDel');
        @NetShareEnum:=GetProcAddress(hNetAPI32_DLL, 'NetShareEnum');
        @NetShareGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetShareGetInfo');
        @NetShareSetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetShareSetInfo');

              //Statistics Function
        @NetStatisticsGet:=GetProcAddress(hNetAPI32_DLL, 'NetStatisticsGet');

              //Use Functions
        @NetUseAdd:=GetProcAddress(hNetAPI32_DLL, 'NetUseAdd');
        @NetUseDel:=GetProcAddress(hNetAPI32_DLL, 'NetUseDel');
        @NetUseEnum:=GetProcAddress(hNetAPI32_DLL, 'NetUseEnum');
        @NetUseGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetUseGetInfo');

              //User Functions
        @NetUserAdd:=GetProcAddress(hNetAPI32_DLL, 'NetUserAdd');
        @NetUserChangePassword:=GetProcAddress(hNetAPI32_DLL, 'NetUserChangePassword');
        @NetUserDel:=GetProcAddress(hNetAPI32_DLL, 'NetUserDel');
        @NetUserEnum:=GetProcAddress(hNetAPI32_DLL, 'NetUserEnum');
        @NetUserGetGroups:=GetProcAddress(hNetAPI32_DLL, 'NetUserGetGroups');
        @NetUserGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetUserGetInfo');
        @NetUserGetLocalGroups:=GetProcAddress(hNetAPI32_DLL, 'NetUserGetLocalGroups');
        @NetUserSetGroups:=GetProcAddress(hNetAPI32_DLL, 'NetUserSetGroups');
        @NetUserSetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetUserSetInfo');

              //User Modals Functions
        @NetUserModalsGet:=GetProcAddress(hNetAPI32_DLL, 'NetUserModalsGet');
        @NetUserModalsSet:=GetProcAddress(hNetAPI32_DLL, 'NetUserModalsSet');

              //Workstation and Workstation User Functions
        @NetWkstaGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetWkstaGetInfo');
        @NetWkstaSetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetWkstaSetInfo');
        @NetWkstaUserGetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetWkstaUserGetInfo');
        @NetWkstaUserSetInfo:=GetProcAddress(hNetAPI32_DLL, 'NetWkstaUserSetInfo');
        @NetWkstaUserEnum:=GetProcAddress(hNetAPI32_DLL, 'NetWkstaUserEnum');
    END ELSE {error condition ...};
END;

INITIALIZATION
    LoadLib;
FINALIZATION
    IF Iloaded THEN FreeLibrary(hNetAPI32_DLL);
END.
