TYPE
    NET_API_STATUS=DWORD;

    _DFS_INFO_1=RECORD
        EntryPath:LPWSTR;
    END;
    DFS_INFO_1=_DFS_INFO_1;
    PDFS_INFO_1=^_DFS_INFO_1;
    LPDFS_INFO_1=^_DFS_INFO_1;

    _DFS_INFO_2=RECORD
        EntryPath:LPWSTR;
        Comment:LPWSTR;
        State:DWORD;
        NumberOfStorages:DWORD;
    END;
    DFS_INFO_2=_DFS_INFO_2;
    PDFS_INFO_2=^_DFS_INFO_2;
    LPDFS_INFO_2=^_DFS_INFO_2;

    _DFS_STORAGE_INFO=RECORD
        State:ULONG;
        ServerName:LPWSTR;
        ShareName:LPWSTR;
    END;
    DFS_STORAGE_INFO=_DFS_STORAGE_INFO;
    PDFS_STORAGE_INFO=^_DFS_STORAGE_INFO;
    LPDFS_STORAGE_INFO=^_DFS_STORAGE_INFO;

    _DFS_INFO_3=RECORD
        EntryPath:LPWSTR;
        Comment:LPWSTR;
        State:DWORD;
        NumberOfStorages:DWORD;
        Storage:LPDFS_STORAGE_INFO;
    END;
    DFS_INFO_3=_DFS_INFO_3;
    PDFS_INFO_3=^_DFS_INFO_3;
    LPDFS_INFO_3=^_DFS_INFO_3;

    _DFS_INFO_4=RECORD
        EntryPath:LPWSTR;
        Comment:LPWSTR;
        State:DWORD;
        Timeout:ULONG;
        Guid:TGUID;
        NumberOfStorages:DWORD;
        Storage:LPDFS_STORAGE_INFO;
    END;
    DFS_INFO_4=_DFS_INFO_4;
    PDFS_INFO_4=^_DFS_INFO_4;
    LPDFS_INFO_4=^_DFS_INFO_4;

    _DFS_INFO_100=RECORD
        Comment:LPWSTR;
    END;
    DFS_INFO_100=_DFS_INFO_100;
    PDFS_INFO_100=^_DFS_INFO_100;
    LPDFS_INFO_100=^_DFS_INFO_100;

    _DFS_INFO_101=RECORD
        State:DWORD;
    END;
    DFS_INFO_101=_DFS_INFO_101;
    PDFS_INFO_101=^_DFS_INFO_101;
    LPDFS_INFO_101=^_DFS_INFO_101;

    _DFS_INFO_102=RECORD
        Timeout:ULONG;
    END;
    DFS_INFO_102=_DFS_INFO_102;
    PDFS_INFO_102=^_DFS_INFO_102;
    LPDFS_INFO_102=^_DFS_INFO_102;

    _DFS_INFO_200=RECORD
        FtDfsName:LPWSTR;
    END;
    DFS_INFO_200=_DFS_INFO_200;
    PDFS_INFO_200=^_DFS_INFO_200;
    LPDFS_INFO_200=^_DFS_INFO_200;

    DFS_SITENAME_INFO=RECORD
        SiteFlags:ULONG;
        SiteName:LPWSTR;
    END;
    PDFS_SITENAME_INFO=^DFS_SITENAME_INFO;
    LPDFS_SITENAME_INFO=^DFS_SITENAME_INFO;

    DFS_SITELIST_INFO=RECORD
        cSites:ULONG;
        Site:DFS_SITENAME_INFO;
    END;
    PDFS_SITELIST_INFO=^DFS_SITELIST_INFO;
    LPDFS_SITELIST_INFO=^DFS_SITELIST_INFO;

    _SHARE_INFO_0=RECORD
        shi0_netname:LPTSTR;
    END;
    SHARE_INFO_0=_SHARE_INFO_0;
    PSHARE_INFO_0=^_SHARE_INFO_0;
    LPSHARE_INFO_0=^_SHARE_INFO_0;

    _SHARE_INFO_1=RECORD
        shi1_netname:LPTSTR;
        shi1_type:DWORD;
        shi1_remark:LPTSTR;
    END;
    SHARE_INFO_1=_SHARE_INFO_1;
    PSHARE_INFO_1=^_SHARE_INFO_1;
    LPSHARE_INFO_1=^_SHARE_INFO_1;

    _SHARE_INFO_2=RECORD
        shi2_netname:LPTSTR;
        shi2_type:DWORD;
        shi2_remark:LPTSTR;
        shi2_permissions:DWORD;
        shi2_max_uses:DWORD;
        shi2_current_uses:DWORD;
        shi2_path:LPTSTR;
        shi2_passwd:LPTSTR;
    END;
    SHARE_INFO_2=_SHARE_INFO_2;
    PSHARE_INFO_2=^_SHARE_INFO_2;
    LPSHARE_INFO_2=^_SHARE_INFO_2;

    _SHARE_INFO_501=RECORD
        shi501_netname:LPTSTR;
        shi501_type:DWORD;
        shi501_remark:LPTSTR;
        shi501_flags:DWORD;
    END;
    SHARE_INFO_501=_SHARE_INFO_501;
    PSHARE_INFO_501=^_SHARE_INFO_501;
    LPSHARE_INFO_501=^_SHARE_INFO_501;

    _SHARE_INFO_502=RECORD
        shi502_netname:LPTSTR;
        shi502_type:DWORD;
        shi502_remark:LPTSTR;
        shi502_permissions:DWORD;
        shi502_max_uses:DWORD;
        shi502_current_uses:DWORD;
        shi502_path:LPTSTR;
        shi502_passwd:LPTSTR;
        shi502_reserved:DWORD;
        shi502_security_descriptor:PSECURITY_DESCRIPTOR;
    END;
    SHARE_INFO_502=_SHARE_INFO_502;
    PSHARE_INFO_502=^_SHARE_INFO_502;
    LPSHARE_INFO_502=^_SHARE_INFO_502;

    _SHARE_INFO_1004=RECORD
        shi1004_remark:LPTSTR;
    END;
    SHARE_INFO_1004=_SHARE_INFO_1004;
    PSHARE_INFO_1004=^_SHARE_INFO_1004;
    LPSHARE_INFO_1004=^_SHARE_INFO_1004;

    _SHARE_INFO_1005=RECORD
        shi1005_flags:DWORD;
    END;
    SHARE_INFO_1005=_SHARE_INFO_1005;
    PSHARE_INFO_1005=^_SHARE_INFO_1005;
    LPSHARE_INFO_1005=^_SHARE_INFO_1005;

    _SHARE_INFO_1006=RECORD
        shi1006_max_uses:DWORD;
    END;
    SHARE_INFO_1006=_SHARE_INFO_1006;
    PSHARE_INFO_1006=^_SHARE_INFO_1006;
    LPSHARE_INFO_1006=^_SHARE_INFO_1006;

    _SHARE_INFO_1501=RECORD
        shi1501_reserved:DWORD;
        shi1501_security_descriptor:PSECURITY_DESCRIPTOR;
    END;
    SHARE_INFO_1501=_SHARE_INFO_1501;
    PSHARE_INFO_1501=^_SHARE_INFO_1501;
    LPSHARE_INFO_1501=^_SHARE_INFO_1501;

    _SESSION_INFO_0=RECORD
        sesi0_cname:LPTSTR;
    END;
    SESSION_INFO_0=_SESSION_INFO_0;
    PSESSION_INFO_0=^_SESSION_INFO_0;
    LPSESSION_INFO_0=^_SESSION_INFO_0;

    _SESSION_INFO_1=RECORD
        sesi1_cname:LPTSTR;
        sesi1_username:LPTSTR;
        sesi1_num_opens:DWORD;
        sesi1_time:DWORD;
        sesi1_idle_time:DWORD;
        sesi1_user_flags:DWORD;
    END;
    SESSION_INFO_1=_SESSION_INFO_1;
    PSESSION_INFO_1=^_SESSION_INFO_1;
    LPSESSION_INFO_1=^_SESSION_INFO_1;

    _SESSION_INFO_2=RECORD
        sesi2_cname:LPTSTR;
        sesi2_username:LPTSTR;
        sesi2_num_opens:DWORD;
        sesi2_time:DWORD;
        sesi2_idle_time:DWORD;
        sesi2_user_flags:DWORD;
        sesi2_cltype_name:LPTSTR;
    END;
    SESSION_INFO_2=_SESSION_INFO_2;
    PSESSION_INFO_2=^_SESSION_INFO_2;
    LPSESSION_INFO_2=^_SESSION_INFO_2;

    _SESSION_INFO_10=RECORD
        sesi10_cname:LPTSTR;
        sesi10_username:LPTSTR;
        sesi10_time:DWORD;
        sesi10_idle_time:DWORD;
    END;
    SESSION_INFO_10=_SESSION_INFO_10;
    PSESSION_INFO_10=^_SESSION_INFO_10;
    LPSESSION_INFO_10=^_SESSION_INFO_10;

    _SESSION_INFO_502=RECORD
        sesi502_cname:LPTSTR;
        sesi502_username:LPTSTR;
        sesi502_num_opens:DWORD;
        sesi502_time:DWORD;
        sesi502_idle_time:DWORD;
        sesi502_user_flags:DWORD;
        sesi502_cltype_name:LPTSTR;
        sesi502_transport:LPTSTR;
    END;
    SESSION_INFO_502=_SESSION_INFO_502;
    PSESSION_INFO_502=^_SESSION_INFO_502;
    LPSESSION_INFO_502=^_SESSION_INFO_502;

    _CONNECTION_INFO_0=RECORD
        coni0_id:DWORD;
    END;
    CONNECTION_INFO_0=_CONNECTION_INFO_0;
    PCONNECTION_INFO_0=^_CONNECTION_INFO_0;
    LPCONNECTION_INFO_0=^_CONNECTION_INFO_0;

    _CONNECTION_INFO_1=RECORD
        coni1_id:DWORD;
        coni1_type:DWORD;
        coni1_num_opens:DWORD;
        coni1_num_users:DWORD;
        coni1_time:DWORD;
        coni1_username:LPTSTR;
        coni1_netname:LPTSTR;
    END;
    CONNECTION_INFO_1=_CONNECTION_INFO_1;
    PCONNECTION_INFO_1=^_CONNECTION_INFO_1;
    LPCONNECTION_INFO_1=^_CONNECTION_INFO_1;

    _FILE_INFO_2=RECORD
        fi2_id:DWORD;
    END;
    FILE_INFO_2=_FILE_INFO_2;
    PFILE_INFO_2=^_FILE_INFO_2;
    LPFILE_INFO_2=^_FILE_INFO_2;

    _FILE_INFO_3=RECORD
        fi3_id:DWORD;
        fi3_permissions:DWORD;
        fi3_num_locks:DWORD;
        fi3_pathname:LPTSTR;
        fi3_username:LPTSTR;
    END;
    FILE_INFO_3=_FILE_INFO_3;
    PFILE_INFO_3=^_FILE_INFO_3;
    LPFILE_INFO_3=^_FILE_INFO_3;

    _REPL_INFO_0=RECORD
        rp0_role:DWORD;
        rp0_exportpath:LPWSTR;
        rp0_exportlist:LPWSTR;
        rp0_importpath:LPWSTR;
        rp0_importlist:LPWSTR;
        rp0_logonusername:LPWSTR;
        rp0_interval:DWORD;
        rp0_pulse:DWORD;
        rp0_guardtime:DWORD;
        rp0_random:DWORD;
    END;
    REPL_INFO_0=_REPL_INFO_0;
    PREPL_INFO_0=^_REPL_INFO_0;
    LPREPL_INFO_0=^_REPL_INFO_0;

    _REPL_INFO_1000=RECORD
        rp1000_interval:DWORD;
    END;
    REPL_INFO_1000=_REPL_INFO_1000;
    PREPL_INFO_1000=^_REPL_INFO_1000;
    LPREPL_INFO_1000=^_REPL_INFO_1000;

    _REPL_INFO_1001=RECORD
        rp1001_pulse:DWORD;
    END;
    REPL_INFO_1001=_REPL_INFO_1001;
    PREPL_INFO_1001=^_REPL_INFO_1001;
    LPREPL_INFO_1001=^_REPL_INFO_1001;

    _REPL_INFO_1002=RECORD
        rp1002_guardtime:DWORD;
    END;
    REPL_INFO_1002=_REPL_INFO_1002;
    PREPL_INFO_1002=^_REPL_INFO_1002;
    LPREPL_INFO_1002=^_REPL_INFO_1002;

    _REPL_INFO_1003=RECORD
        rp1003_random:DWORD;
    END;
    REPL_INFO_1003=_REPL_INFO_1003;
    PREPL_INFO_1003=^_REPL_INFO_1003;
    LPREPL_INFO_1003=^_REPL_INFO_1003;

    _REPL_EDIR_INFO_0=RECORD
        rped0_dirname:LPWSTR;
    END;
    REPL_EDIR_INFO_0=_REPL_EDIR_INFO_0;
    PREPL_EDIR_INFO_0=^_REPL_EDIR_INFO_0;
    LPREPL_EDIR_INFO_0=^_REPL_EDIR_INFO_0;

    _REPL_EDIR_INFO_1=RECORD
        rped1_dirname:LPWSTR;
        rped1_integrity:DWORD;
        rped1_extent:DWORD;
    END;
    REPL_EDIR_INFO_1=_REPL_EDIR_INFO_1;
    PREPL_EDIR_INFO_1=^_REPL_EDIR_INFO_1;
    LPREPL_EDIR_INFO_1=^_REPL_EDIR_INFO_1;

    _REPL_EDIR_INFO_2=RECORD
        rped2_dirname:LPWSTR;
        rped2_integrity:DWORD;
        rped2_extent:DWORD;
        rped2_lockcount:DWORD;
        rped2_locktime:DWORD;
    END;
    REPL_EDIR_INFO_2=_REPL_EDIR_INFO_2;
    PREPL_EDIR_INFO_2=^_REPL_EDIR_INFO_2;
    LPREPL_EDIR_INFO_2=^_REPL_EDIR_INFO_2;

    _REPL_EDIR_INFO_1000=RECORD
        rped1000_integrity:DWORD;
    END;
    REPL_EDIR_INFO_1000=_REPL_EDIR_INFO_1000;
    PREPL_EDIR_INFO_1000=^_REPL_EDIR_INFO_1000;
    LPREPL_EDIR_INFO_1000=^_REPL_EDIR_INFO_1000;

    _REPL_EDIR_INFO_1001=RECORD
        rped1001_extent:DWORD;
    END;
    REPL_EDIR_INFO_1001=_REPL_EDIR_INFO_1001;
    PREPL_EDIR_INFO_1001=^_REPL_EDIR_INFO_1001;
    LPREPL_EDIR_INFO_1001=^_REPL_EDIR_INFO_1001;

    _REPL_IDIR_INFO_0=RECORD
        rpid0_dirname:LPWSTR;
    END;
    REPL_IDIR_INFO_0=_REPL_IDIR_INFO_0;
    PREPL_IDIR_INFO_0=^_REPL_IDIR_INFO_0;
    LPREPL_IDIR_INFO_0=^_REPL_IDIR_INFO_0;

    _REPL_IDIR_INFO_1=RECORD
        rpid1_dirname:LPWSTR;
        rpid1_state:DWORD;
        rpid1_mastername:LPWSTR;
        rpid1_last_update_time:DWORD;
        rpid1_lockcount:DWORD;
        rpid1_locktime:DWORD;
    END;
    REPL_IDIR_INFO_1=_REPL_IDIR_INFO_1;
    PREPL_IDIR_INFO_1=^_REPL_IDIR_INFO_1;
    LPREPL_IDIR_INFO_1=^_REPL_IDIR_INFO_1;

    _TIME_OF_DAY_INFO=RECORD
        tod_elapsedt:DWORD;
        tod_msecs:DWORD;
        tod_hours:DWORD;
        tod_mins:DWORD;
        tod_secs:DWORD;
        tod_hunds:DWORD;
        tod_timezone:LONGINT;
        tod_tinterval:DWORD;
        tod_day:DWORD;
        tod_month:DWORD;
        tod_year:DWORD;
        tod_weekday:DWORD;
    END;
    TIME_OF_DAY_INFO=_TIME_OF_DAY_INFO;
    PTIME_OF_DAY_INFO=^_TIME_OF_DAY_INFO;
    LPTIME_OF_DAY_INFO=^_TIME_OF_DAY_INFO;

{I am not sure of this translation :( ... this means it may prove wrong!!!}
    _NETSETUP_NAME_TYPE=DWORD;
    NETSETUP_NAME_TYPE=_NETSETUP_NAME_TYPE;
    PNETSETUP_NAME_TYPE=^_NETSETUP_NAME_TYPE;

    _NETSETUP_JOIN_STATUS=DWORD;
    NETSETUP_JOIN_STATUS=_NETSETUP_JOIN_STATUS;
    PNETSETUP_JOIN_STATUS=^_NETSETUP_JOIN_STATUS;

{$IFDEF LM20_WORKSTATION_STATISTICS}
    _STAT_WORKSTATION_0=RECORD
        stw0_start:DWORD;
        stw0_numNCB_r:DWORD;
        stw0_numNCB_s:DWORD;
        stw0_numNCB_a:DWORD;
        stw0_fiNCB_r:DWORD;
        stw0_fiNCB_s:DWORD;
        stw0_fiNCB_a:DWORD;
        stw0_fcNCB_r:DWORD;
        stw0_fcNCB_s:DWORD;
        stw0_fcNCB_a:DWORD;
        stw0_sesstart:DWORD;
        stw0_sessfailcon:DWORD;
        stw0_sessbroke:DWORD;
        stw0_uses:DWORD;
        stw0_usefail:DWORD;
        stw0_autorec:DWORD;
        stw0_bytessent_r_lo:DWORD;
        stw0_bytessent_r_hi:DWORD;
        stw0_bytesrcvd_r_lo:DWORD;
        stw0_bytesrcvd_r_hi:DWORD;
        stw0_bytessent_s_lo:DWORD;
        stw0_bytessent_s_hi:DWORD;
        stw0_bytesrcvd_s_lo:DWORD;
        stw0_bytesrcvd_s_hi:DWORD;
        stw0_bytessent_a_lo:DWORD;
        stw0_bytessent_a_hi:DWORD;
        stw0_bytesrcvd_a_lo:DWORD;
        stw0_bytesrcvd_a_hi:DWORD;
        stw0_reqbufneed:DWORD;
        stw0_bigbufneed:DWORD;
    END;
    STAT_WORKSTATION_0=_STAT_WORKSTATION_0;
    PSTAT_WORKSTATION_0=^_STAT_WORKSTATION_0;
    LPSTAT_WORKSTATION_0=^_STAT_WORKSTATION_0;

{$ELSE}
    _STAT_WORKSTATION_0=RECORD
        StatisticsStartTime:LARGE_INTEGER;
        BytesReceived:LARGE_INTEGER;
        SmbsReceived:LARGE_INTEGER;
        PagingReadBytesRequested:LARGE_INTEGER;
        NonPagingReadBytesRequested:LARGE_INTEGER;
        CacheReadBytesRequested:LARGE_INTEGER;
        NetworkReadBytesRequested:LARGE_INTEGER;
        BytesTransmitted:LARGE_INTEGER;
        SmbsTransmitted:LARGE_INTEGER;
        PagingWriteBytesRequested:LARGE_INTEGER;
        NonPagingWriteBytesRequested:LARGE_INTEGER;
        CacheWriteBytesRequested:LARGE_INTEGER;
        NetworkWriteBytesRequested:LARGE_INTEGER;
        InitiallyFailedOperations:DWORD;
        FailedCompletionOperations:DWORD;
        ReadOperations:DWORD;
        RandomReadOperations:DWORD;
        ReadSmbs:DWORD;
        LargeReadSmbs:DWORD;
        SmallReadSmbs:DWORD;
        WriteOperations:DWORD;
        RandomWriteOperations:DWORD;
        WriteSmbs:DWORD;
        LargeWriteSmbs:DWORD;
        SmallWriteSmbs:DWORD;
        RawReadsDenied:DWORD;
        RawWritesDenied:DWORD;
        NetworkErrors:DWORD;
        Sessions:DWORD;
        FailedSessions:DWORD;
        Reconnects:DWORD;
        CoreConnects:DWORD;
        Lanman20Connects:DWORD;
        Lanman21Connects:DWORD;
        LanmanNtConnects:DWORD;
        ServerDisconnects:DWORD;
        HungSessions:DWORD;
        UseCount:DWORD;
        FailedUseCount:DWORD;
        CurrentCommands:DWORD;
    END;
    STAT_WORKSTATION_0=_STAT_WORKSTATION_0;
    PSTAT_WORKSTATION_0=^_STAT_WORKSTATION_0;
    LPSTAT_WORKSTATION_0=^_STAT_WORKSTATION_0;
{$ENDIF}

    _STAT_SERVER_0=RECORD
        sts0_start:DWORD;
        sts0_fopens:DWORD;
        sts0_devopens:DWORD;
        sts0_jobsqueued:DWORD;
        sts0_sopens:DWORD;
        sts0_stimedout:DWORD;
        sts0_serrorout:DWORD;
        sts0_pwerrors:DWORD;
        sts0_permerrors:DWORD;
        sts0_syserrors:DWORD;
        sts0_bytessent_low:DWORD;
        sts0_bytessent_high:DWORD;
        sts0_bytesrcvd_low:DWORD;
        sts0_bytesrcvd_high:DWORD;
        sts0_avresponse:DWORD;
        sts0_reqbufneed:DWORD;
        sts0_bigbufneed:DWORD;
    END;
    STAT_SERVER_0=_STAT_SERVER_0;
    PSTAT_SERVER_0=^_STAT_SERVER_0;
    LPSTAT_SERVER_0=^_STAT_SERVER_0;

    _USE_INFO_0=RECORD
        ui0_local:PWideChar;
        ui0_remote:PWideChar;
    END;
    USE_INFO_0=_USE_INFO_0;
    PUSE_INFO_0=^_USE_INFO_0;
    LPUSE_INFO_0=^_USE_INFO_0;

    _USE_INFO_1=RECORD
        ui1_local:PWideChar;
        ui1_remote:PWideChar;
        ui1_password:PWideChar;
        ui1_status:DWORD;
        ui1_asg_type:DWORD;
        ui1_refcount:DWORD;
        ui1_usecount:DWORD;
    END;
    USE_INFO_1=_USE_INFO_1;
    PUSE_INFO_1=^_USE_INFO_1;
    LPUSE_INFO_1=^_USE_INFO_1;

    _USE_INFO_2=RECORD
        ui2_local:PWideChar;
        ui2_remote:PWideChar;
        ui2_password:PWideChar;
        ui2_status:DWORD;
        ui2_asg_type:DWORD;
        ui2_refcount:DWORD;
        ui2_usecount:DWORD;
        ui2_username:PWideChar;
        ui2_domainname:PWideChar;
    END;
    USE_INFO_2=_USE_INFO_2;
    PUSE_INFO_2=^_USE_INFO_2;
    LPUSE_INFO_2=^_USE_INFO_2;

    _USE_INFO_3=RECORD
        ui3_ui2:USE_INFO_2;
        ui3_flags:ULONG;
    END;
    USE_INFO_3=_USE_INFO_3;
    PUSE_INFO_3=^_USE_INFO_3;
    LPUSE_INFO_3=^_USE_INFO_3;

    _MSG_INFO_0=RECORD
        msgi0_name:LPWSTR;
    END;
    MSG_INFO_0=_MSG_INFO_0;
    PMSG_INFO_0=^_MSG_INFO_0;
    LPMSG_INFO_0=^_MSG_INFO_0;

    _MSG_INFO_1=RECORD
        msgi1_name:LPWSTR;
        msgi1_forward_flag:DWORD;
        msgi1_forward:LPWSTR;
    END;
    MSG_INFO_1=_MSG_INFO_1;
    PMSG_INFO_1=^_MSG_INFO_1;
    LPMSG_INFO_1=^_MSG_INFO_1;

    _AT_INFO=RECORD
        JobTime:PDWORD;
        DaysOfMonth:DWORD;
        DaysOfWeek:UCHAR;
        Flags:UCHAR;
        Command:LPWSTR;
    END;
    AT_INFO=_AT_INFO;
    PAT_INFO=^_AT_INFO;
    LPAT_INFO=^_AT_INFO;

    _AT_ENUM=RECORD
        JobId:DWORD;
        JobTime:PDWORD;
        DaysOfMonth:DWORD;
        DaysOfWeek:UCHAR;
        Flags:UCHAR;
        Command:LPWSTR;
    END;
    AT_ENUM=_AT_ENUM;
    PAT_ENUM=^_AT_ENUM;
    LPAT_ENUM=^_AT_ENUM;

    _STD_ALERT=RECORD
        alrt_timestamp:DWORD;
        alrt_eventname:ARRAY[0..EVLEN] OF WCHAR;
        alrt_servicename:ARRAY[0..SNLEN] OF WCHAR;
    END;
    STD_ALERT=_STD_ALERT;
    PSTD_ALERT=^_STD_ALERT;
    LPSTD_ALERT=^_STD_ALERT;

    _ADMIN_OTHER_INFO=RECORD
        alrtad_errcode:DWORD;
        alrtad_numstrings:DWORD;
    END;
    ADMIN_OTHER_INFO=_ADMIN_OTHER_INFO;
    PADMIN_OTHER_INFO=^_ADMIN_OTHER_INFO;
    LPADMIN_OTHER_INFO=^_ADMIN_OTHER_INFO;

    _ERRLOG_OTHER_INFO=RECORD
        alrter_errcode:DWORD;
        alrter_offset:DWORD;
    END;
    ERRLOG_OTHER_INFO=_ERRLOG_OTHER_INFO;
    PERRLOG_OTHER_INFO=^_ERRLOG_OTHER_INFO;
    LPERRLOG_OTHER_INFO=^_ERRLOG_OTHER_INFO;

    _PRINT_OTHER_INFO=RECORD
        alrtpr_jobid:DWORD;
        alrtpr_status:DWORD;
        alrtpr_submitted:DWORD;
        alrtpr_size:DWORD;
    END;
    PRINT_OTHER_INFO=_PRINT_OTHER_INFO;
    PPRINT_OTHER_INFO=^_PRINT_OTHER_INFO;
    LPPRINT_OTHER_INFO=^_PRINT_OTHER_INFO;

    _USER_OTHER_INFO=RECORD
        alrtus_errcode:DWORD;
        alrtus_numstrings:DWORD;
    END;
    USER_OTHER_INFO=_USER_OTHER_INFO;
    PUSER_OTHER_INFO=^_USER_OTHER_INFO;
    LPUSER_OTHER_INFO=^_USER_OTHER_INFO;

    _LOCALGROUP_INFO_0=RECORD
        lgrpi0_name:PWideChar;
    END;
    LOCALGROUP_INFO_0=_LOCALGROUP_INFO_0;
    PLOCALGROUP_INFO_0=^_LOCALGROUP_INFO_0;
    LPLOCALGROUP_INFO_0=^_LOCALGROUP_INFO_0;

    _LOCALGROUP_INFO_1=RECORD
        lgrpi1_name:PWideChar;
        lgrpi1_comment:PWideChar;
    END;
    LOCALGROUP_INFO_1=_LOCALGROUP_INFO_1;
    PLOCALGROUP_INFO_1=^_LOCALGROUP_INFO_1;
    LPLOCALGROUP_INFO_1=^_LOCALGROUP_INFO_1;

    _LOCALGROUP_INFO_1002=RECORD
        lgrpi1002_comment:PWideChar;
    END;
    LOCALGROUP_INFO_1002=_LOCALGROUP_INFO_1002;
    PLOCALGROUP_INFO_1002=^_LOCALGROUP_INFO_1002;
    LPLOCALGROUP_INFO_1002=^_LOCALGROUP_INFO_1002;

    _LOCALGROUP_MEMBERS_INFO_0=RECORD
        lgrmi0_sid:PSID;
    END;
    LOCALGROUP_MEMBERS_INFO_0=_LOCALGROUP_MEMBERS_INFO_0;
    PLOCALGROUP_MEMBERS_INFO_0=^_LOCALGROUP_MEMBERS_INFO_0;
    LPLOCALGROUP_MEMBERS_INFO_0=^_LOCALGROUP_MEMBERS_INFO_0;

    _LOCALGROUP_MEMBERS_INFO_1=RECORD
        lgrmi1_sid:PSID;
        lgrmi1_sidusage:SID_NAME_USE;
        lgrmi1_name:PWideChar;
    END;
    LOCALGROUP_MEMBERS_INFO_1=_LOCALGROUP_MEMBERS_INFO_1;
    PLOCALGROUP_MEMBERS_INFO_1=^_LOCALGROUP_MEMBERS_INFO_1;
    LPLOCALGROUP_MEMBERS_INFO_1=^_LOCALGROUP_MEMBERS_INFO_1;

    _LOCALGROUP_MEMBERS_INFO_2=RECORD
        lgrmi2_sid:PSID;
        lgrmi2_sidusage:SID_NAME_USE;
        lgrmi2_domainandname:PWideChar;
    END;
    LOCALGROUP_MEMBERS_INFO_2=_LOCALGROUP_MEMBERS_INFO_2;
    PLOCALGROUP_MEMBERS_INFO_2=^_LOCALGROUP_MEMBERS_INFO_2;
    LPLOCALGROUP_MEMBERS_INFO_2=^_LOCALGROUP_MEMBERS_INFO_2;

    _LOCALGROUP_MEMBERS_INFO_3=RECORD
        lgrmi3_domainandname:PWideChar;
    END;
    LOCALGROUP_MEMBERS_INFO_3=_LOCALGROUP_MEMBERS_INFO_3;
    PLOCALGROUP_MEMBERS_INFO_3=^_LOCALGROUP_MEMBERS_INFO_3;
    LPLOCALGROUP_MEMBERS_INFO_3=^_LOCALGROUP_MEMBERS_INFO_3;

    _LOCALGROUP_USERS_INFO_0=RECORD
        lgrui0_name:PWideChar;
    END;
    LOCALGROUP_USERS_INFO_0=_LOCALGROUP_USERS_INFO_0;
    PLOCALGROUP_USERS_INFO_0=^_LOCALGROUP_USERS_INFO_0;
    LPLOCALGROUP_USERS_INFO_0=^_LOCALGROUP_USERS_INFO_0;

    _NET_DISPLAY_USER=RECORD
        usri1_name:PWideChar;
        usri1_comment:PWideChar;
        usri1_flags:DWORD;
        usri1_full_name:PWideChar;
        usri1_user_id:DWORD;
        usri1_next_index:DWORD;
    END;
    NET_DISPLAY_USER=_NET_DISPLAY_USER;
    PNET_DISPLAY_USER=^_NET_DISPLAY_USER;

    _NET_DISPLAY_MACHINE=RECORD
        usri2_name:PWideChar;
        usri2_comment:PWideChar;
        usri2_flags:DWORD;
        usri2_user_id:DWORD;
        usri2_next_index:DWORD;
    END;
    NET_DISPLAY_MACHINE=_NET_DISPLAY_MACHINE;
    PNET_DISPLAY_MACHINE=^_NET_DISPLAY_MACHINE;

    _NET_DISPLAY_GROUP=RECORD
        grpi3_name:PWideChar;
        grpi3_comment:PWideChar;
        grpi3_group_id:DWORD;
        grpi3_attributes:DWORD;
        grpi3_next_index:DWORD;
    END;
    NET_DISPLAY_GROUP=_NET_DISPLAY_GROUP;
    PNET_DISPLAY_GROUP=^_NET_DISPLAY_GROUP;

    _GROUP_INFO_0=RECORD
        grpi0_name:PWideChar;
    END;
    GROUP_INFO_0=_GROUP_INFO_0;
    PGROUP_INFO_0=^_GROUP_INFO_0;
    LPGROUP_INFO_0=^_GROUP_INFO_0;

    _GROUP_INFO_1=RECORD
        grpi1_name:PWideChar;
        grpi1_comment:PWideChar;
    END;
    GROUP_INFO_1=_GROUP_INFO_1;
    PGROUP_INFO_1=^_GROUP_INFO_1;
    LPGROUP_INFO_1=^_GROUP_INFO_1;

    _GROUP_INFO_2=RECORD
        grpi2_name:PWideChar;
        grpi2_comment:PWideChar;
        grpi2_group_id:DWORD;
        grpi2_attributes:DWORD;
    END;
    GROUP_INFO_2=_GROUP_INFO_2;
    PGROUP_INFO_2=^_GROUP_INFO_2;

    _GROUP_INFO_1002=RECORD
        grpi1002_comment:PWideChar;
    END;
    GROUP_INFO_1002=_GROUP_INFO_1002;
    PGROUP_INFO_1002=^_GROUP_INFO_1002;
    LPGROUP_INFO_1002=^_GROUP_INFO_1002;

    _GROUP_INFO_1005=RECORD
        grpi1005_attributes:DWORD;
    END;
    GROUP_INFO_1005=_GROUP_INFO_1005;
    PGROUP_INFO_1005=^_GROUP_INFO_1005;
    LPGROUP_INFO_1005=^_GROUP_INFO_1005;

    _GROUP_USERS_INFO_0=RECORD
        grui0_name:PWideChar;
    END;
    GROUP_USERS_INFO_0=_GROUP_USERS_INFO_0;
    PGROUP_USERS_INFO_0=^_GROUP_USERS_INFO_0;
    LPGROUP_USERS_INFO_0=^_GROUP_USERS_INFO_0;

    _GROUP_USERS_INFO_1=RECORD
        grui1_name:PWideChar;
        grui1_attributes:DWORD;
    END;
    GROUP_USERS_INFO_1=_GROUP_USERS_INFO_1;
    PGROUP_USERS_INFO_1=^_GROUP_USERS_INFO_1;
    LPGROUP_USERS_INFO_1=^_GROUP_USERS_INFO_1;
    _USER_INFO_0=RECORD
        usri0_name:PWideChar;
    END;
    USER_INFO_0=_USER_INFO_0;
    PUSER_INFO_0=^_USER_INFO_0;
    LPUSER_INFO_0=^_USER_INFO_0;

    _USER_INFO_1=RECORD
        usri1_name:PWideChar;
        usri1_password:PWideChar;
        usri1_password_age:DWORD;
        usri1_priv:DWORD;
        usri1_home_dir:PWideChar;
        usri1_comment:PWideChar;
        usri1_flags:DWORD;
        usri1_script_path:PWideChar;
    END;
    USER_INFO_1=_USER_INFO_1;
    PUSER_INFO_1=^_USER_INFO_1;
    LPUSER_INFO_1=^_USER_INFO_1;

    _USER_INFO_2=RECORD
        usri2_name:PWideChar;
        usri2_password:PWideChar;
        usri2_password_age:DWORD;
        usri2_priv:DWORD;
        usri2_home_dir:PWideChar;
        usri2_comment:PWideChar;
        usri2_flags:DWORD;
        usri2_script_path:PWideChar;
        usri2_auth_flags:DWORD;
        usri2_full_name:PWideChar;
        usri2_usr_comment:PWideChar;
        usri2_parms:PWideChar;
        usri2_workstations:PWideChar;
        usri2_last_logon:DWORD;
        usri2_last_logoff:DWORD;
        usri2_acct_expires:DWORD;
        usri2_max_storage:DWORD;
        usri2_units_per_week:DWORD;
        usri2_logon_hours:PBYTE;
        usri2_bad_pw_count:DWORD;
        usri2_num_logons:DWORD;
        usri2_logon_server:PWideChar;
        usri2_country_code:DWORD;
        usri2_code_page:DWORD;
    END;
    USER_INFO_2=_USER_INFO_2;
    PUSER_INFO_2=^_USER_INFO_2;
    LPUSER_INFO_2=^_USER_INFO_2;

    _USER_INFO_3=RECORD
        usri3_name:PWideChar;
        usri3_password:PWideChar;
        usri3_password_age:DWORD;
        usri3_priv:DWORD;
        usri3_home_dir:PWideChar;
        usri3_comment:PWideChar;
        usri3_flags:DWORD;
        usri3_script_path:PWideChar;
        usri3_auth_flags:DWORD;
        usri3_full_name:PWideChar;
        usri3_usr_comment:PWideChar;
        usri3_parms:PWideChar;
        usri3_workstations:PWideChar;
        usri3_last_logon:DWORD;
        usri3_last_logoff:DWORD;
        usri3_acct_expires:DWORD;
        usri3_max_storage:DWORD;
        usri3_units_per_week:DWORD;
        usri3_logon_hours:PBYTE;
        usri3_bad_pw_count:DWORD;
        usri3_num_logons:DWORD;
        usri3_logon_server:PWideChar;
        usri3_country_code:DWORD;
        usri3_code_page:DWORD;
        usri3_user_id:DWORD;
        usri3_primary_group_id:DWORD;
        usri3_profile:PWideChar;
        usri3_home_dir_drive:PWideChar;
        usri3_password_expired:DWORD;
    END;
    USER_INFO_3=_USER_INFO_3;
    PUSER_INFO_3=^_USER_INFO_3;
    LPUSER_INFO_3=^_USER_INFO_3;

    _USER_INFO_10=RECORD
        usri10_name:PWideChar;
        usri10_comment:PWideChar;
        usri10_usr_comment:PWideChar;
        usri10_full_name:PWideChar;
    END;
    USER_INFO_10=_USER_INFO_10;
    PUSER_INFO_10=^_USER_INFO_10;
    LPUSER_INFO_10=^_USER_INFO_10;

    _USER_INFO_11=RECORD
        usri11_name:PWideChar;
        usri11_comment:PWideChar;
        usri11_usr_comment:PWideChar;
        usri11_full_name:PWideChar;
        usri11_priv:DWORD;
        usri11_auth_flags:DWORD;
        usri11_password_age:DWORD;
        usri11_home_dir:PWideChar;
        usri11_parms:PWideChar;
        usri11_last_logon:DWORD;
        usri11_last_logoff:DWORD;
        usri11_bad_pw_count:DWORD;
        usri11_num_logons:DWORD;
        usri11_logon_server:PWideChar;
        usri11_country_code:DWORD;
        usri11_workstations:PWideChar;
        usri11_max_storage:DWORD;
        usri11_units_per_week:DWORD;
        usri11_logon_hours:PBYTE;
        usri11_code_page:DWORD;
    END;
    USER_INFO_11=_USER_INFO_11;
    PUSER_INFO_11=^_USER_INFO_11;
    LPUSER_INFO_11=^_USER_INFO_11;

    _USER_INFO_20=RECORD
        usri20_name:PWideChar;
        usri20_full_name:PWideChar;
        usri20_comment:PWideChar;
        usri20_flags:DWORD;
        usri20_user_id:DWORD;
    END;
    USER_INFO_20=_USER_INFO_20;
    PUSER_INFO_20=^_USER_INFO_20;
    LPUSER_INFO_20=^_USER_INFO_20;

    _USER_INFO_21=RECORD
        usri21_password:ARRAY[0..ENCRYPTED_PWLEN-1] OF BYTE;
    END;
    USER_INFO_21=_USER_INFO_21;
    PUSER_INFO_21=^_USER_INFO_21;
    LPUSER_INFO_21=^_USER_INFO_21;

    _USER_INFO_22=RECORD
        usri22_name:PWideChar;
        usri22_password:ARRAY[0..ENCRYPTED_PWLEN] OF BYTE;
        usri22_password_age:DWORD;
        usri22_priv:DWORD;
        usri22_home_dir:PWideChar;
        usri22_comment:PWideChar;
        usri22_flags:DWORD;
        usri22_script_path:PWideChar;
        usri22_auth_flags:DWORD;
        usri22_full_name:PWideChar;
        usri22_usr_comment:PWideChar;
        usri22_parms:PWideChar;
        usri22_workstations:PWideChar;
        usri22_last_logon:DWORD;
        usri22_last_logoff:DWORD;
        usri22_acct_expires:DWORD;
        usri22_max_storage:DWORD;
        usri22_units_per_week:DWORD;
        usri22_logon_hours:PBYTE;
        usri22_bad_pw_count:DWORD;
        usri22_num_logons:DWORD;
        usri22_logon_server:PWideChar;
        usri22_country_code:DWORD;
        usri22_code_page:DWORD;
    END;
    USER_INFO_22=_USER_INFO_22;
    PUSER_INFO_22=^_USER_INFO_22;
    LPUSER_INFO_22=^_USER_INFO_22;

    _USER_INFO_1003=RECORD
        usri1003_password:PWideChar;
    END;
    USER_INFO_1003=_USER_INFO_1003;
    PUSER_INFO_1003=^_USER_INFO_1003;
    LPUSER_INFO_1003=^_USER_INFO_1003;

    _USER_INFO_1005=RECORD
        usri1005_priv:DWORD;
    END;
    USER_INFO_1005=_USER_INFO_1005;
    PUSER_INFO_1005=^_USER_INFO_1005;
    LPUSER_INFO_1005=^_USER_INFO_1005;

    _USER_INFO_1006=RECORD
        usri1006_home_dir:PWideChar;
    END;
    USER_INFO_1006=_USER_INFO_1006;
    PUSER_INFO_1006=^_USER_INFO_1006;
    LPUSER_INFO_1006=^_USER_INFO_1006;

    _USER_INFO_1007=RECORD
        usri1007_comment:PWideChar;
    END;
    USER_INFO_1007=_USER_INFO_1007;
    PUSER_INFO_1007=^_USER_INFO_1007;
    LPUSER_INFO_1007=^_USER_INFO_1007;

    _USER_INFO_1008=RECORD
        usri1008_flags:DWORD;
    END;
    USER_INFO_1008=_USER_INFO_1008;
    PUSER_INFO_1008=^_USER_INFO_1008;
    LPUSER_INFO_1008=^_USER_INFO_1008;

    _USER_INFO_1009=RECORD
        usri1009_script_path:PWideChar;
    END;
    USER_INFO_1009=_USER_INFO_1009;
    PUSER_INFO_1009=^_USER_INFO_1009;
    LPUSER_INFO_1009=^_USER_INFO_1009;

    _USER_INFO_1010=RECORD
        usri1010_auth_flags:DWORD;
    END;
    USER_INFO_1010=_USER_INFO_1010;
    PUSER_INFO_1010=^_USER_INFO_1010;
    LPUSER_INFO_1010=^_USER_INFO_1010;

    _USER_INFO_1011=RECORD
        usri1011_full_name:PWideChar;
    END;
    USER_INFO_1011=_USER_INFO_1011;
    PUSER_INFO_1011=^_USER_INFO_1011;
    LPUSER_INFO_1011=^_USER_INFO_1011;

    _USER_INFO_1012=RECORD
        usri1012_usr_comment:PWideChar;
    END;
    USER_INFO_1012=_USER_INFO_1012;
    PUSER_INFO_1012=^_USER_INFO_1012;
    LPUSER_INFO_1012=^_USER_INFO_1012;

    _USER_INFO_1013=RECORD
        usri1013_parms:PWideChar;
    END;
    USER_INFO_1013=_USER_INFO_1013;
    PUSER_INFO_1013=^_USER_INFO_1013;
    LPUSER_INFO_1013=^_USER_INFO_1013;

    _USER_INFO_1014=RECORD
        usri1014_workstations:PWideChar;
    END;
    USER_INFO_1014=_USER_INFO_1014;
    PUSER_INFO_1014=^_USER_INFO_1014;
    LPUSER_INFO_1014=^_USER_INFO_1014;

    _USER_INFO_1017=RECORD
        usri1017_acct_expires:DWORD;
    END;
    USER_INFO_1017=_USER_INFO_1017;
    PUSER_INFO_1017=^_USER_INFO_1017;
    LPUSER_INFO_1017=^_USER_INFO_1017;

    _USER_INFO_1018=RECORD
        usri1018_max_storage:DWORD;
    END;
    USER_INFO_1018=_USER_INFO_1018;
    PUSER_INFO_1018=^_USER_INFO_1018;
    LPUSER_INFO_1018=^_USER_INFO_1018;

    _USER_INFO_1020=RECORD
        usri1020_units_per_week:DWORD;
        usri1020_logon_hours:PBYTE;
    END;
    USER_INFO_1020=_USER_INFO_1020;
    PUSER_INFO_1020=^_USER_INFO_1020;
    LPUSER_INFO_1020=^_USER_INFO_1020;

    _USER_INFO_1023=RECORD
        usri1023_logon_server:PWideChar;
    END;
    USER_INFO_1023=_USER_INFO_1023;
    PUSER_INFO_1023=^_USER_INFO_1023;
    LPUSER_INFO_1023=^_USER_INFO_1023;

    _USER_INFO_1024=RECORD
        usri1024_country_code:DWORD;
    END;
    USER_INFO_1024=_USER_INFO_1024;
    PUSER_INFO_1024=^_USER_INFO_1024;
    LPUSER_INFO_1024=^_USER_INFO_1024;

    _USER_INFO_1025=RECORD
        usri1025_code_page:DWORD;
    END;
    USER_INFO_1025=_USER_INFO_1025;
    PUSER_INFO_1025=^_USER_INFO_1025;
    LPUSER_INFO_1025=^_USER_INFO_1025;

    _USER_INFO_1051=RECORD
        usri1051_primary_group_id:DWORD;
    END;
    USER_INFO_1051=_USER_INFO_1051;
    PUSER_INFO_1051=^_USER_INFO_1051;
    LPUSER_INFO_1051=^_USER_INFO_1051;

    _USER_INFO_1052=RECORD
        usri1052_profile:PWideChar;
    END;
    USER_INFO_1052=_USER_INFO_1052;
    PUSER_INFO_1052=^_USER_INFO_1052;
    LPUSER_INFO_1052=^_USER_INFO_1052;

    _USER_INFO_1053=RECORD
        usri1053_home_dir_drive:PWideChar;
    END;
    USER_INFO_1053=_USER_INFO_1053;
    PUSER_INFO_1053=^_USER_INFO_1053;
    LPUSER_INFO_1053=^_USER_INFO_1053;

    _USER_MODALS_INFO_0=RECORD
        usrmod0_min_passwd_len:DWORD;
        usrmod0_max_passwd_age:DWORD;
        usrmod0_min_passwd_age:DWORD;
        usrmod0_force_logoff:DWORD;
        usrmod0_password_hist_len:DWORD;
    END;
    USER_MODALS_INFO_0=_USER_MODALS_INFO_0;
    PUSER_MODALS_INFO_0=^_USER_MODALS_INFO_0;
    LPUSER_MODALS_INFO_0=^_USER_MODALS_INFO_0;

    _USER_MODALS_INFO_1=RECORD
        usrmod1_role:DWORD;
        usrmod1_primary:PWideChar;
    END;
    USER_MODALS_INFO_1=_USER_MODALS_INFO_1;
    PUSER_MODALS_INFO_1=^_USER_MODALS_INFO_1;
    LPUSER_MODALS_INFO_1=^_USER_MODALS_INFO_1;

    _USER_MODALS_INFO_2=RECORD
        usrmod2_domain_name:PWideChar;
        usrmod2_domain_id:PSID;
    END;
    USER_MODALS_INFO_2=_USER_MODALS_INFO_2;
    PUSER_MODALS_INFO_2=^_USER_MODALS_INFO_2;
    LPUSER_MODALS_INFO_2=^_USER_MODALS_INFO_2;

    _USER_MODALS_INFO_3=RECORD
        usrmod3_lockout_duration:DWORD;
        usrmod3_lockout_observation_window:DWORD;
        usrmod3_lockout_threshold:DWORD;
    END;
    USER_MODALS_INFO_3=_USER_MODALS_INFO_3;
    PUSER_MODALS_INFO_3=^_USER_MODALS_INFO_3;
    LPUSER_MODALS_INFO_3=^_USER_MODALS_INFO_3;

    _USER_MODALS_INFO_1001=RECORD
        usrmod1001_min_passwd_len:DWORD;
    END;
    USER_MODALS_INFO_1001=_USER_MODALS_INFO_1001;
    PUSER_MODALS_INFO_1001=^_USER_MODALS_INFO_1001;
    LPUSER_MODALS_INFO_1001=^_USER_MODALS_INFO_1001;

    _USER_MODALS_INFO_1002=RECORD
        usrmod1002_max_passwd_age:DWORD;
    END;
    USER_MODALS_INFO_1002=_USER_MODALS_INFO_1002;
    PUSER_MODALS_INFO_1002=^_USER_MODALS_INFO_1002;
    LPUSER_MODALS_INFO_1002=^_USER_MODALS_INFO_1002;

    _USER_MODALS_INFO_1003=RECORD
        usrmod1003_min_passwd_age:DWORD;
    END;
    USER_MODALS_INFO_1003=_USER_MODALS_INFO_1003;
    PUSER_MODALS_INFO_1003=^_USER_MODALS_INFO_1003;
    LPUSER_MODALS_INFO_1003=^_USER_MODALS_INFO_1003;

    _USER_MODALS_INFO_1004=RECORD
        usrmod1004_force_logoff:DWORD;
    END;
    USER_MODALS_INFO_1004=_USER_MODALS_INFO_1004;
    PUSER_MODALS_INFO_1004=^_USER_MODALS_INFO_1004;
    LPUSER_MODALS_INFO_1004=^_USER_MODALS_INFO_1004;

    _USER_MODALS_INFO_1005=RECORD
        usrmod1005_password_hist_len:DWORD;
    END;
    USER_MODALS_INFO_1005=_USER_MODALS_INFO_1005;
    PUSER_MODALS_INFO_1005=^_USER_MODALS_INFO_1005;
    LPUSER_MODALS_INFO_1005=^_USER_MODALS_INFO_1005;

    _USER_MODALS_INFO_1006=RECORD
        usrmod1006_role:DWORD;
    END;
    USER_MODALS_INFO_1006=_USER_MODALS_INFO_1006;
    PUSER_MODALS_INFO_1006=^_USER_MODALS_INFO_1006;
    LPUSER_MODALS_INFO_1006=^_USER_MODALS_INFO_1006;

    _USER_MODALS_INFO_1007=RECORD
        usrmod1007_primary:PWideChar;
    END;
    USER_MODALS_INFO_1007=_USER_MODALS_INFO_1007;
    PUSER_MODALS_INFO_1007=^_USER_MODALS_INFO_1007;
    LPUSER_MODALS_INFO_1007=^_USER_MODALS_INFO_1007;

    _NETLOGON_INFO_1=RECORD
        netlog1_flags:DWORD;
        netlog1_pdc_connection_status:NET_API_STATUS;
    END;
    NETLOGON_INFO_1=_NETLOGON_INFO_1;
    PNETLOGON_INFO_1=^_NETLOGON_INFO_1;

    _NETLOGON_INFO_2=RECORD
        netlog2_flags:DWORD;
        netlog2_pdc_connection_status:NET_API_STATUS;
        netlog2_trusted_dc_name:PWideChar;
        netlog2_tc_connection_status:NET_API_STATUS;
    END;
    NETLOGON_INFO_2=_NETLOGON_INFO_2;
    PNETLOGON_INFO_2=^_NETLOGON_INFO_2;

    _NETLOGON_INFO_3=RECORD
        netlog3_flags:DWORD;
        netlog3_logon_attempts:DWORD;
        netlog3_reserved1:DWORD;
        netlog3_reserved2:DWORD;
        netlog3_reserved3:DWORD;
        netlog3_reserved4:DWORD;
        netlog3_reserved5:DWORD;
    END;
    NETLOGON_INFO_3=_NETLOGON_INFO_3;
    PNETLOGON_INFO_3=^_NETLOGON_INFO_3;

    _NETLOGON_INFO_4=RECORD
        netlog4_trusted_dc_name:PWideChar;
        netlog4_trusted_domain_name:PWideChar;
    END;
    NETLOGON_INFO_4=_NETLOGON_INFO_4;
    PNETLOGON_INFO_4=^_NETLOGON_INFO_4;


    _WKSTA_INFO_100=RECORD
        wki100_platform_id:DWORD;
        wki100_computername:PWideChar;
        wki100_langroup:PWideChar;
        wki100_ver_major:DWORD;
        wki100_ver_minor:DWORD;
    END;
    WKSTA_INFO_100=_WKSTA_INFO_100;
    PWKSTA_INFO_100=^_WKSTA_INFO_100;
    LPWKSTA_INFO_100=^_WKSTA_INFO_100;

    _WKSTA_INFO_101=RECORD
        wki101_platform_id:DWORD;
        wki101_computername:PWideChar;
        wki101_langroup:PWideChar;
        wki101_ver_major:DWORD;
        wki101_ver_minor:DWORD;
        wki101_lanroot:PWideChar;
    END;
    WKSTA_INFO_101=_WKSTA_INFO_101;
    PWKSTA_INFO_101=^_WKSTA_INFO_101;
    LPWKSTA_INFO_101=^_WKSTA_INFO_101;

    _WKSTA_INFO_102=RECORD
        wki102_platform_id:DWORD;
        wki102_computername:PWideChar;
        wki102_langroup:PWideChar;
        wki102_ver_major:DWORD;
        wki102_ver_minor:DWORD;
        wki102_lanroot:PWideChar;
        wki102_logged_on_users:DWORD;
    END;
    WKSTA_INFO_102=_WKSTA_INFO_102;
    PWKSTA_INFO_102=^_WKSTA_INFO_102;
    LPWKSTA_INFO_102=^_WKSTA_INFO_102;

    _WKSTA_INFO_302=RECORD
        wki302_char_wait:DWORD;
        wki302_collection_time:DWORD;
        wki302_maximum_collection_count:DWORD;
        wki302_keep_conn:DWORD;
        wki302_keep_search:DWORD;
        wki302_max_cmds:DWORD;
        wki302_num_work_buf:DWORD;
        wki302_siz_work_buf:DWORD;
        wki302_max_wrk_cache:DWORD;
        wki302_sess_timeout:DWORD;
        wki302_siz_error:DWORD;
        wki302_num_alerts:DWORD;
        wki302_num_services:DWORD;
        wki302_errlog_sz:DWORD;
        wki302_print_buf_time:DWORD;
        wki302_num_char_buf:DWORD;
        wki302_siz_char_buf:DWORD;
        wki302_wrk_heuristics:PWideChar;
        wki302_mailslots:DWORD;
        wki302_num_dgram_buf:DWORD;
    END;
    WKSTA_INFO_302=_WKSTA_INFO_302;
    PWKSTA_INFO_302=^_WKSTA_INFO_302;
    LPWKSTA_INFO_302=^_WKSTA_INFO_302;

    _WKSTA_INFO_402=RECORD
        wki402_char_wait:DWORD;
        wki402_collection_time:DWORD;
        wki402_maximum_collection_count:DWORD;
        wki402_keep_conn:DWORD;
        wki402_keep_search:DWORD;
        wki402_max_cmds:DWORD;
        wki402_num_work_buf:DWORD;
        wki402_siz_work_buf:DWORD;
        wki402_max_wrk_cache:DWORD;
        wki402_sess_timeout:DWORD;
        wki402_siz_error:DWORD;
        wki402_num_alerts:DWORD;
        wki402_num_services:DWORD;
        wki402_errlog_sz:DWORD;
        wki402_print_buf_time:DWORD;
        wki402_num_char_buf:DWORD;
        wki402_siz_char_buf:DWORD;
        wki402_wrk_heuristics:PWideChar;
        wki402_mailslots:DWORD;
        wki402_num_dgram_buf:DWORD;
        wki402_max_threads:DWORD;
    END;
    WKSTA_INFO_402=_WKSTA_INFO_402;
    PWKSTA_INFO_402=^_WKSTA_INFO_402;
    LPWKSTA_INFO_402=^_WKSTA_INFO_402;

    _WKSTA_INFO_502=RECORD
        wki502_char_wait:DWORD;
        wki502_collection_time:DWORD;
        wki502_maximum_collection_count:DWORD;
        wki502_keep_conn:DWORD;
        wki502_max_cmds:DWORD;
        wki502_sess_timeout:DWORD;
        wki502_siz_char_buf:DWORD;
        wki502_max_threads:DWORD;
        wki502_lock_quota:DWORD;
        wki502_lock_increment:DWORD;
        wki502_lock_maximum:DWORD;
        wki502_pipe_increment:DWORD;
        wki502_pipe_maximum:DWORD;
        wki502_cache_file_timeout:DWORD;
        wki502_dormant_file_limit:DWORD;
        wki502_read_ahead_throughput:DWORD;
        wki502_num_mailslot_buffers:DWORD;
        wki502_num_srv_announce_buffers:DWORD;
        wki502_max_illegal_datagram_events:DWORD;
        wki502_illegal_datagram_event_reset_frequency:DWORD;
        wki502_log_election_packets:LongBool;
        wki502_use_opportunistic_locking:LongBool;
        wki502_use_unlock_behind:LongBool;
        wki502_use_close_behind:LongBool;
        wki502_buf_named_pipes:LongBool;
        wki502_use_lock_read_unlock:LongBool;
        wki502_utilize_nt_caching:LongBool;
        wki502_use_raw_read:LongBool;
        wki502_use_raw_write:LongBool;
        wki502_use_write_raw_data:LongBool;
        wki502_use_encryption:LongBool;
        wki502_buf_files_deny_write:LongBool;
        wki502_buf_read_only_files:LongBool;
        wki502_force_core_create_mode:LongBool;
        wki502_use_512_byte_max_transfer:LongBool;
    END;
    WKSTA_INFO_502=_WKSTA_INFO_502;
    PWKSTA_INFO_502=^_WKSTA_INFO_502;
    LPWKSTA_INFO_502=^_WKSTA_INFO_502;

    _WKSTA_INFO_1010=RECORD
        wki1010_char_wait:DWORD;
    END;
    WKSTA_INFO_1010=_WKSTA_INFO_1010;
    PWKSTA_INFO_1010=^_WKSTA_INFO_1010;
    LPWKSTA_INFO_1010=^_WKSTA_INFO_1010;

    _WKSTA_INFO_1011=RECORD
        wki1011_collection_time:DWORD;
    END;
    WKSTA_INFO_1011=_WKSTA_INFO_1011;
    PWKSTA_INFO_1011=^_WKSTA_INFO_1011;
    LPWKSTA_INFO_1011=^_WKSTA_INFO_1011;

    _WKSTA_INFO_1012=RECORD
        wki1012_maximum_collection_count:DWORD;
    END;
    WKSTA_INFO_1012=_WKSTA_INFO_1012;
    PWKSTA_INFO_1012=^_WKSTA_INFO_1012;
    LPWKSTA_INFO_1012=^_WKSTA_INFO_1012;

    _WKSTA_INFO_1027=RECORD
        wki1027_errlog_sz:DWORD;
    END;
    WKSTA_INFO_1027=_WKSTA_INFO_1027;
    PWKSTA_INFO_1027=^_WKSTA_INFO_1027;
    LPWKSTA_INFO_1027=^_WKSTA_INFO_1027;

    _WKSTA_INFO_1028=RECORD
        wki1028_print_buf_time:DWORD;
    END;
    WKSTA_INFO_1028=_WKSTA_INFO_1028;
    PWKSTA_INFO_1028=^_WKSTA_INFO_1028;
    LPWKSTA_INFO_1028=^_WKSTA_INFO_1028;

    _WKSTA_INFO_1032=RECORD
        wki1032_wrk_heuristics:DWORD;
    END;
    WKSTA_INFO_1032=_WKSTA_INFO_1032;
    PWKSTA_INFO_1032=^_WKSTA_INFO_1032;
    LPWKSTA_INFO_1032=^_WKSTA_INFO_1032;

    _WKSTA_INFO_1013=RECORD
        wki1013_keep_conn:DWORD;
    END;
    WKSTA_INFO_1013=_WKSTA_INFO_1013;
    PWKSTA_INFO_1013=^_WKSTA_INFO_1013;
    LPWKSTA_INFO_1013=^_WKSTA_INFO_1013;

    _WKSTA_INFO_1018=RECORD
        wki1018_sess_timeout:DWORD;
    END;
    WKSTA_INFO_1018=_WKSTA_INFO_1018;
    PWKSTA_INFO_1018=^_WKSTA_INFO_1018;
    LPWKSTA_INFO_1018=^_WKSTA_INFO_1018;

    _WKSTA_INFO_1023=RECORD
        wki1023_siz_char_buf:DWORD;
    END;
    WKSTA_INFO_1023=_WKSTA_INFO_1023;
    PWKSTA_INFO_1023=^_WKSTA_INFO_1023;
    LPWKSTA_INFO_1023=^_WKSTA_INFO_1023;

    _WKSTA_INFO_1033=RECORD
        wki1033_max_threads:DWORD;
    END;
    WKSTA_INFO_1033=_WKSTA_INFO_1033;
    PWKSTA_INFO_1033=^_WKSTA_INFO_1033;
    LPWKSTA_INFO_1033=^_WKSTA_INFO_1033;

    _WKSTA_INFO_1041=RECORD
        wki1041_lock_quota:DWORD;
    END;
    WKSTA_INFO_1041=_WKSTA_INFO_1041;
    PWKSTA_INFO_1041=^_WKSTA_INFO_1041;
    LPWKSTA_INFO_1041=^_WKSTA_INFO_1041;

    _WKSTA_INFO_1042=RECORD
        wki1042_lock_increment:DWORD;
    END;
    WKSTA_INFO_1042=_WKSTA_INFO_1042;
    PWKSTA_INFO_1042=^_WKSTA_INFO_1042;
    LPWKSTA_INFO_1042=^_WKSTA_INFO_1042;

    _WKSTA_INFO_1043=RECORD
        wki1043_lock_maximum:DWORD;
    END;
    WKSTA_INFO_1043=_WKSTA_INFO_1043;
    PWKSTA_INFO_1043=^_WKSTA_INFO_1043;
    LPWKSTA_INFO_1043=^_WKSTA_INFO_1043;

    _WKSTA_INFO_1044=RECORD
        wki1044_pipe_increment:DWORD;
    END;
    WKSTA_INFO_1044=_WKSTA_INFO_1044;
    PWKSTA_INFO_1044=^_WKSTA_INFO_1044;
    LPWKSTA_INFO_1044=^_WKSTA_INFO_1044;

    _WKSTA_INFO_1045=RECORD
        wki1045_pipe_maximum:DWORD;
    END;
    WKSTA_INFO_1045=_WKSTA_INFO_1045;
    PWKSTA_INFO_1045=^_WKSTA_INFO_1045;
    LPWKSTA_INFO_1045=^_WKSTA_INFO_1045;

    _WKSTA_INFO_1046=RECORD
        wki1046_dormant_file_limit:DWORD;
    END;
    WKSTA_INFO_1046=_WKSTA_INFO_1046;
    PWKSTA_INFO_1046=^_WKSTA_INFO_1046;
    LPWKSTA_INFO_1046=^_WKSTA_INFO_1046;

    _WKSTA_INFO_1047=RECORD
        wki1047_cache_file_timeout:DWORD;
    END;
    WKSTA_INFO_1047=_WKSTA_INFO_1047;
    PWKSTA_INFO_1047=^_WKSTA_INFO_1047;
    LPWKSTA_INFO_1047=^_WKSTA_INFO_1047;

    _WKSTA_INFO_1048=RECORD
        wki1048_use_opportunistic_locking:LongBool;
    END;
    WKSTA_INFO_1048=_WKSTA_INFO_1048;
    PWKSTA_INFO_1048=^_WKSTA_INFO_1048;
    LPWKSTA_INFO_1048=^_WKSTA_INFO_1048;

    _WKSTA_INFO_1049=RECORD
        wki1049_use_unlock_behind:LongBool;
    END;
    WKSTA_INFO_1049=_WKSTA_INFO_1049;
    PWKSTA_INFO_1049=^_WKSTA_INFO_1049;
    LPWKSTA_INFO_1049=^_WKSTA_INFO_1049;

    _WKSTA_INFO_1050=RECORD
        wki1050_use_close_behind:LongBool;
    END;
    WKSTA_INFO_1050=_WKSTA_INFO_1050;
    PWKSTA_INFO_1050=^_WKSTA_INFO_1050;
    LPWKSTA_INFO_1050=^_WKSTA_INFO_1050;

    _WKSTA_INFO_1051=RECORD
        wki1051_buf_named_pipes:LongBool;
    END;
    WKSTA_INFO_1051=_WKSTA_INFO_1051;
    PWKSTA_INFO_1051=^_WKSTA_INFO_1051;
    LPWKSTA_INFO_1051=^_WKSTA_INFO_1051;

    _WKSTA_INFO_1052=RECORD
        wki1052_use_lock_read_unlock:LongBool;
    END;
    WKSTA_INFO_1052=_WKSTA_INFO_1052;
    PWKSTA_INFO_1052=^_WKSTA_INFO_1052;
    LPWKSTA_INFO_1052=^_WKSTA_INFO_1052;

    _WKSTA_INFO_1053=RECORD
        wki1053_utilize_nt_caching:LongBool;
    END;
    WKSTA_INFO_1053=_WKSTA_INFO_1053;
    PWKSTA_INFO_1053=^_WKSTA_INFO_1053;
    LPWKSTA_INFO_1053=^_WKSTA_INFO_1053;

    _WKSTA_INFO_1054=RECORD
        wki1054_use_raw_read:LongBool;
    END;
    WKSTA_INFO_1054=_WKSTA_INFO_1054;
    PWKSTA_INFO_1054=^_WKSTA_INFO_1054;
    LPWKSTA_INFO_1054=^_WKSTA_INFO_1054;

    _WKSTA_INFO_1055=RECORD
        wki1055_use_raw_write:LongBool;
    END;
    WKSTA_INFO_1055=_WKSTA_INFO_1055;
    PWKSTA_INFO_1055=^_WKSTA_INFO_1055;
    LPWKSTA_INFO_1055=^_WKSTA_INFO_1055;

    _WKSTA_INFO_1056=RECORD
        wki1056_use_write_raw_data:LongBool;
    END;
    WKSTA_INFO_1056=_WKSTA_INFO_1056;
    PWKSTA_INFO_1056=^_WKSTA_INFO_1056;
    LPWKSTA_INFO_1056=^_WKSTA_INFO_1056;

    _WKSTA_INFO_1057=RECORD
        wki1057_use_encryption:LongBool;
    END;
    WKSTA_INFO_1057=_WKSTA_INFO_1057;
    PWKSTA_INFO_1057=^_WKSTA_INFO_1057;
    LPWKSTA_INFO_1057=^_WKSTA_INFO_1057;

    _WKSTA_INFO_1058=RECORD
        wki1058_buf_files_deny_write:LongBool;
    END;
    WKSTA_INFO_1058=_WKSTA_INFO_1058;
    PWKSTA_INFO_1058=^_WKSTA_INFO_1058;
    LPWKSTA_INFO_1058=^_WKSTA_INFO_1058;

    _WKSTA_INFO_1059=RECORD
        wki1059_buf_read_only_files:LongBool;
    END;
    WKSTA_INFO_1059=_WKSTA_INFO_1059;
    PWKSTA_INFO_1059=^_WKSTA_INFO_1059;
    LPWKSTA_INFO_1059=^_WKSTA_INFO_1059;

    _WKSTA_INFO_1060=RECORD
        wki1060_force_core_create_mode:LongBool;
    END;
    WKSTA_INFO_1060=_WKSTA_INFO_1060;
    PWKSTA_INFO_1060=^_WKSTA_INFO_1060;
    LPWKSTA_INFO_1060=^_WKSTA_INFO_1060;

    _WKSTA_INFO_1061=RECORD
        wki1061_use_512_byte_max_transfer:LongBool;
    END;
    WKSTA_INFO_1061=_WKSTA_INFO_1061;
    PWKSTA_INFO_1061=^_WKSTA_INFO_1061;
    LPWKSTA_INFO_1061=^_WKSTA_INFO_1061;

    _WKSTA_INFO_1062=RECORD
        wki1062_read_ahead_throughput:DWORD;
    END;
    WKSTA_INFO_1062=_WKSTA_INFO_1062;
    PWKSTA_INFO_1062=^_WKSTA_INFO_1062;
    LPWKSTA_INFO_1062=^_WKSTA_INFO_1062;

    _WKSTA_USER_INFO_0=RECORD
        wkui0_username:PWideChar;
    END;
    WKSTA_USER_INFO_0=_WKSTA_USER_INFO_0;
    PWKSTA_USER_INFO_0=^_WKSTA_USER_INFO_0;
    LPWKSTA_USER_INFO_0=^_WKSTA_USER_INFO_0;

    _WKSTA_USER_INFO_1=RECORD
        wkui1_username:PWideChar;
        wkui1_logon_domain:PWideChar;
        wkui1_oth_domains:PWideChar;
        wkui1_logon_server:PWideChar;
    END;
    WKSTA_USER_INFO_1=_WKSTA_USER_INFO_1;
    PWKSTA_USER_INFO_1=^_WKSTA_USER_INFO_1;
    LPWKSTA_USER_INFO_1=^_WKSTA_USER_INFO_1;

    _WKSTA_USER_INFO_1101=RECORD
        wkui1101_oth_domains:PWideChar;
    END;
    WKSTA_USER_INFO_1101=_WKSTA_USER_INFO_1101;
    PWKSTA_USER_INFO_1101=^_WKSTA_USER_INFO_1101;
    LPWKSTA_USER_INFO_1101=^_WKSTA_USER_INFO_1101;

    _WKSTA_TRANSPORT_INFO_0=RECORD
        wkti0_quality_of_service:DWORD;
        wkti0_number_of_vcs:DWORD;
        wkti0_transport_name:PWideChar;
        wkti0_transport_address:PWideChar;
        wkti0_wan_ish:LongBool;
    END;
    WKSTA_TRANSPORT_INFO_0=_WKSTA_TRANSPORT_INFO_0;
    PWKSTA_TRANSPORT_INFO_0=^_WKSTA_TRANSPORT_INFO_0;
    LPWKSTA_TRANSPORT_INFO_0=^_WKSTA_TRANSPORT_INFO_0;
