unit convu1;
//up to now 20.11.2000 2:03 UA-time I got almost everything
//concerning the constant definitions

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    RichEdit2: TRichEdit;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  numdefine,
  numif,
  numendif,
  numbracketsop,
  numbracketscl:longint;

implementation

{$R *.DFM}

function pos(substr,s:string):longint;
//case insensitive search
var i,len1,len2:longint;
begin
     len1:=length(substr);
     len2:=length(s);
     for i:=1 to len2 do begin
         if lstrcmpi(pchar(substr),pchar(copy(s,i,len1)))=0 then begin
            result:=i;
            exit;
         end;
     end;
     result:=0;
end;

function globreplace(substr,newsubstr:string;s:string):string;
var dummy:string;
    posi:longint;
begin
     result:=s;
     if pos(substr,newsubstr)<>0 then exit;
     dummy:=s;
     repeat
           posi:=pos(substr,dummy);
           if posi<>0 then begin
              delete(dummy,posi,length(substr));
              insert(newsubstr,dummy,posi);
           end;
     until posi=0;
     result:=dummy;
end;

function atpos(pos:longint;substr,s:string):boolean;
begin
     result:=false;
     if lstrcmpi(pchar(substr),pchar(copy(s,pos,length(substr))))=0 then result:=true;
end;

function findall(inpstr:string):string;
var position,popped:longint;
    dummy:string;
var lasttype:byte;
    needme2,
    needme:boolean;

    function conv_define(inp:string):string;
    var dum:string;

        function treatline(s:string):string;
        var dum2,part1,part2:string;
            posit,pos2:longint;
            function evenquotes(S1:string):boolean;
            var i,j:integer;
            begin
                 j:=0;
                 for i:=1 to length(s1) do if s1[i]='"' then inc(j);
                 result:=j mod 2=0
            end;
        begin
             dum2:=copy(s,8,length(s));
             if pos(' ',dum2)<>0 then begin
                posit:=pos(' ',dum2);
                dum2[posit]:='=';
                pos2:=pos('//',dum2);
                if pos2<>0 then begin
                   while ((pos(' ',dum2)>0) and (pos(' ',dum2)<pos('//',dum2))) do begin
                         if evenquotes(copy(dum2,1,(pos(' ',dum2)))) then
                            delete(dum2,pos(' ',dum2),1)
                         else break;
                   end;
                end else while pos(' ',dum2)>0 do begin
                               if evenquotes(copy(dum2,1,(pos(' ',dum2)))) then
                                  delete(dum2,pos(' ',dum2),1)
                               else break;
                         end;
             end;
             if pos('=',dum2)<>0 then begin
                part1:=copy(dum2,1,pos('=',dum2));
                part2:=copy(dum2,pos('=',dum2)+1,length(dum2));
                if part2<>'' then begin
                   part2:=globreplace('|',' or ',part2);
                   part2:=globreplace('&',' and ',part2);
                   part2:=globreplace('0x','$',part2);
                   part2:=globreplace('(unsignedlong)-1L','LongWord(-1)',part2);
                   part2:=globreplace('(unsignedlong)','LongWord(',part2);
                   part2:=globreplace('L"','''',part2);
                   part2:=globreplace('"','''',part2);
                   part2:=globreplace('"','''',part2);
                   part2:=globreplace('\\','\',part2);

                end;
                if lasttype=3 then dum2:='      '+part1+part2
                   else dum2:='const '+part1+part2;
                while pos(#13#10,dum2)<>0 do
                   delete(dum2,pos(#13#10,dum2),2);
                if pos('//',dum2)<>0 then insert(';',dum2,pos('//',dum2))
                   else dum2:=dum2+';';
             end else dum2:='//#define '+dum2;
             result:=dum2+#13#10;
        end;

        function stripmlsl(inp:string):string;
        var dum1:string;
            c1,c2:longint;
        begin
             dum1:='';
             c1:=0;
             c2:=1;
             repeat
                   inc(c1);
                   if atpos(c1,#13#10,inp) then begin
                      dum1:=dum1+copy(inp,c2,c1-c2);
                      inc(c1,2);
                      c2:=c1+1;
                   end;
             until c1>=length(inp);
             if dum1<>'' then
                while pos('\',dum1)<>0 do
                      delete(dum1,pos('\',dum1),1);
             if dum1='' then dum1:=inp;
             result:=dum1;
        end;

        function strip20define(s:string):string;
        var resu:string;
        begin
             resu:=copy(s,8,length(s));
             while atpos(1,' ',resu) do
                   delete(resu,1,1);
             result:='define '+resu;
        end;

    begin
         dum:='';
         if atpos(1,'ifdef ',inp) then begin
            if pos('\'+#13#10,inp)<>0 then
               dum:='{$'+uppercase(stripmlsl(inp))+'}'
            else dum:='{$'+uppercase(inp)+'}';
         end else
         if atpos(1,'ifndef ',inp) then begin
            if pos('\'+#13#10,inp)<>0 then
               dum:='{$'+uppercase(stripmlsl(inp))+'}'
            else dum:='{$'+uppercase(inp)+'}';
         end else
         if atpos(1,'if ',inp) then begin
            if pos('\'+#13#10,inp)<>0 then
               dum:='{$'+uppercase(stripmlsl(inp))+'}'
            else dum:='{$'+uppercase(inp)+'}';
         end else
         if atpos(1,'endif ',inp) then begin
            if pos('\'+#13#10,inp)<>0 then
               dum:='{$'+uppercase(stripmlsl(inp))+'}'
            else dum:='{$'+uppercase(inp)+'}';
         end else
         if atpos(1,'define ',inp) then begin
            if pos('\'+#13#10,inp)<>0 then
               dum:=treatline(stripmlsl(strip20define(inp)))
            else dum:=treatline(strip20define(inp));
         end;
         result:=dum;
    end;

    function conv_type(s:string):string;
    var
       namepart,
       structpart,
       defpart:string;

       function structstruc(s1:string):string;
       var dum1,vari:string;
           posi1:integer;
       begin
            dum1:=s1;
            result:='';
            posi1:=0;
            while pos(';',dum1)<>0 do begin
//strip any SPACE before the definition
                  while pos(#32,dum1)=1 do
                        delete(dum1,1,1);
                  vari:=copy(dum1,1,pos(#32,dum1)-1);
                  delete(dum1,1,pos(#32,dum1));
                  while pos(#32,dum1)=1 do
                        delete(dum1,1,1);
                  result:=result+copy(dum1,1,pos(';',dum1)-1)+':'+vari+';'+#13#10;
                  delete(dum1,1,pos(';',dum1));
            end;
       end;

       function abrakadabra(s1:string):string;
       var dum1,dum2:string;
       begin
            result:='';
            dum1:=s1;
            if pos(';',dum1)<>0 then dum1[pos(';',dum1)]:=',';
            while pos(#32,dum1)<>0 do delete(dum1,pos(#32,dum1),1);
            while pos(',',dum1)<>0 do begin
                  dum2:=copy(dum1,1,pos(',',dum1)-1);
                  delete(dum1,1,pos(',',dum1));
                  if pos('*',dum2)<>0 then begin
                     delete(dum2,pos('*',dum2),1);
                     result:=result+dum2+'=^'+namepart+';'+#13#10;
                  end else
                     result:=result+dum2+'='+namepart+';'+#13#10;
            end;
       end;

    begin
         namepart:=copy(s,1,pos('{',s)-1);
         structpart:=copy(s,pos('{',s)+1,pos('}',s)-(pos('{',s)+1));
         defpart:=copy(s,pos('}',s)+1,length(s));
         delete(namepart,1,length('typedef struct'));
         while pos(#32,namepart)<>0 do delete(namepart,pos(#32,namepart),1);
         while pos(#13#10,namepart)<>0 do delete(namepart,pos(#13#10,namepart),2);

         while pos(#13#10,structpart)<>0 do delete(structpart,pos(#13#10,structpart),2);

         while pos(#32,defpart)<>0 do delete(defpart,pos(#32,defpart),1);
         while pos(#13#10,defpart)<>0 do delete(defpart,pos(#13#10,defpart),2);


         if lasttype=4 then
         result:=namepart+'=record'+#13#10+
                 structstruc(structpart)+
                 'end;'+#13#10+
                 abrakadabra(defpart)+#13#10
         else
         result:='TYPE'+#13#10+namepart+'=record'+#13#10+
                 structstruc(structpart)+
                 'end;'+#13#10+
                 abrakadabra(defpart)+#13#10;
    end;

begin
        dummy:='';
        position:=0;
        repeat
              inc(position);
              if atpos(position,'//',inpstr) then begin
                 popped:=position;
                 repeat
                       inc(position);
                 until atpos(position,#13#10,inpstr) or (position>=length(inpstr));
                 inc(position);
                 dummy:=dummy+copy(inpstr,popped,position-popped+1);
                 lasttype:=1;
              end else
              if atpos(position,'(*',inpstr) then begin
                 popped:=position;
                 repeat
                       inc(position);
                 until atpos(position,'*)',inpstr) or (position>=length(inpstr));
                 inc(position);
                 dummy:=dummy+copy(inpstr,popped,position-popped+1)+#13#10;
                 lasttype:=2;
              end else
              if atpos(position,'#',inpstr) then begin
                 popped:=position+1;
                 repeat
                       inc(position);
                       if atpos(position,'\'+#13#10,inpstr) then
                          inc(position,3);
                 until atpos(position,#13#10,inpstr) or (position>=length(inpstr));
                 inc(position);
                 dummy:=dummy+conv_define(copy(inpstr,popped,position-popped+1));
                 lasttype:=3;
              end else
              if atpos(position,'typedef struct',inpstr) then begin
                 popped:=position;
                 needme:=false;
                 repeat
                       inc(position);
                 until atpos(position,#13#10,inpstr) or (position>=length(inpstr));
                 inc(position);
                 needme2:=pos('{',copy(inpstr,popped,position-popped+1))>0;
                 if needme2 then begin
                    dec(position);
                    repeat
                       inc(position);
                       if atpos(position,'}',inpstr) then needme:=true;
                    until (needme and atpos(position,';',inpstr)) or (position>=length(inpstr));
                    inc(position);
                 end;
                 dummy:=dummy+conv_type(copy(inpstr,popped,position-popped+1));
                 lasttype:=4;
              end else
              //since we filtered all "typedef struct" we now may try
              //to find further typedefs
              if atpos(position,'typedef',inpstr) then begin
                 popped:=position;
                 needme:=false;
                 repeat
                       inc(position);
                 until atpos(position,#13#10,inpstr) or (position>=length(inpstr));
                 inc(position);
                 needme2:=pos('{',copy(inpstr,popped,position-popped+1))>0;
                 if needme2 then begin
                    dec(position);
                    repeat
                       inc(position);
                       if atpos(position,'}',inpstr) then needme:=true;
                    until (needme and atpos(position,';',inpstr)) or (position>=length(inpstr));
                    inc(position);
                 end;
//this will cause an error in compile time ... but not the only one ;-)))
//the problem is, that I dont really know the C syntax and got no books
//with reserved words, statements and so on ... it is empirical found ... ;-)
                 dummy:=dummy+copy(inpstr,popped,position-popped+1);
                 lasttype:=5;
              end;
        until position>=length(inpstr);
        result:=dummy;
end;

function convert(s:string):string;
var dummy:string;
begin
     dummy:=s;
     dummy:=globreplace('/*','(*',dummy);
     dummy:=globreplace('*/','*)',dummy);
     dummy:=findall(dummy);
     dummy:=globreplace(#13#10+';',';'+#13#10,dummy);
     dummy:=globreplace(#13#10+'}','}'+#13#10,dummy);
     result:=dummy;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     richedit1.Clear;
     richedit2.Clear;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     richedit1.Clear;
     if opendialog1.Execute then
        if opendialog1.FileName<>'' then
           richedit1.Lines.LoadFromFile(opendialog1.FileName);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     savedialog1.FileName:=copy(opendialog1.filename,1,length(opendialog1.filename)-2)+'.pas';
     if savedialog1.Execute then
        if savedialog1.Filename<>'' then
           richedit2.Lines.SaveToFile(savedialog1.Filename);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     richedit2.Clear;
     richedit2.lines.text:=convert(richedit1.Lines.text);
end;

end.

Comments
    /* -> #13#10+(*
    */ -> *)+#13#10

getexpression
        not inside comment
        linestart -> mutlilined statement
                        does end with ";"
                        may contain "(" and "{" which are closed by "} and ")"
                                -> inside of brackets can be statements of brackets also (incl. "[]" to signalize an array)
                                   these statements are finished by ";" also
                  -> singlelined statement
                        does not end with ";"
                        may end with "\" to continue in the next line


typedef =       type
struct  =       record
*       =       ^

#ifndef _LMUSER_         {$IFNDEF _LMUSER_}
#define _LMUSER_         {$DEFINE _LMUSER_}
#endif                   {$ENDIF}
[instead of "#ifndef":]
#ifdef
#if

#include <lmcons.h>      {$INCLUDE lmcons.h}

#pragma once             [none]







